/* max_testogl.c */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "global.h"

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>

/*-------------------max_test -----------------------------PIPE-----*/

int max_testogl (unit, par, in_u, in_nr, out_o, out_n, deriv_o, deriv_n, h,
	     init_energy, qp_sum, tsim, init_flag, day_of_year)
     int unit;			/* current unit number */
     double **par;		/* parameter array par[unit][1..PARMAX]  */
     int **in_u;		/* input unit array, input connections   */
     int **in_nr;		/* input number array                    */
     double **out_o;		/* output array with privious state      */
     double **out_n;		/* output array with current state       */
     double **deriv_o;		/* derivatives: used for diffential equ. */
     double **deriv_n;		/*  new state of deriv                   */
     double h;			/* sim time step                         */
     double **init_energy;	/* initial energy in RC-comp. [Ws]   */
     double ***qp_sum;		/* energy to one node qp[unit][n][m]     */
     double tsim;		/* simulation time in [s] of this day    */
     int init_flag;		/* set at initial loop of sim            */
     int day_of_year;
{
  /* following comment is used from script etc/xfig.awk   

     TYPE 40
     PRIORITY  12          used by config routine
     HYDRAULIC 1          1-port fluid

     INP1: 0    [-]
     INP2: 0    [-]
     INP3: 0    [-]  
     INP4: 0    [-]
     INP5: 0    [-]
     INP6: 0    [-]
     INP7: 0    [-]
     INP8: 0    [-]
     INP9: 0    [-]
     INP10: 0    [-]
     INP11: 0    [-]
     INP12: 0    [-]
     INP13: 0    [-]
     INP14: 0    [-]
     INP15: 0    [-]
     INP16: 0    [-]
     INP17: 0    [-]
     INP18: 0    [-]

     PAR1: 1  [-]  Online 1 
     PAR2: 3    [-]     plot1 
     PAR3: 0   [-]      min
     PAR4: 100 [-]      max
     PAR5: 0   [-]      min2
     PAR6: 1   [-]      max2
     PAR7: 700 [-] Number of datapoints
     PAR8: 0   [-]
     PAR9: 0   [-] Number of lines

     OUT1: [-]  
     OUT2: [-] 

   */

/*-----*/
  FILE *plotter;
  static int shidparam, shidfdata;
  static int shiddata;
  static int *param;
  static float *shm1, *shm2, *shmparam, *fdata;
  static float *shmdata;
  static float *shared_float_data;

  static int ogl_flag = 1;
  static key_t key, key2, kyeparam, datakey, keyfloat;


/*-----*/


#define N_MAX 100

  int a = 0;
	 /*-----chriwi's debug flag----------------------------*/
  int i = 0;
  int j;
  static int nN;
  static int u, u2;
  static float ax, tx, ax2, tx2;
  int k;
  double input1 = out_n[in_u[unit][1]][in_nr[unit][1]];
  double input2 = out_n[in_u[unit][2]][in_nr[unit][2]];

  float refresh = par[unit][1];	/* read parameter 3 */


  static float *shared_data;
  double out_test1;
  double out_test2;
  static float count = 0;
  static countmax;
  float *malloc_1float ();

/* INIT*/

  if (par[unit][1] != 1)
    return (1);

  if (ogl_flag)
    {
      nN = par[unit][7];
      param = malloc_1int (100);
      shared_data = malloc_1float (50);
      kyeparam = 140;
      datakey = 141;
      keyfloat = 144;

      if ((shidparam =
	   shmget (kyeparam, sizeof (int) * 100, IPC_CREAT | 0666)) < 0)
	{
	  perror ("shmget param");
	  exit (1);
	}
      if ((shmparam = shmat (shidparam, NULL, 0)) == (int *) -1)
	{
	  perror ("shmat param");
	  exit (1);
	}

      /*shared_date */
      if ((shiddata =
	   shmget (datakey, sizeof (float) * 60, IPC_CREAT | 0666)) < 0)
	{
	  perror ("shmget data");
	  exit (1);
	}
      if ((shmdata = shmat (shiddata, NULL, 0)) == (float *) -1)
	{
	  perror ("shmat data");
	  exit (1);
	}



      param = shmparam;

      u = 0;
      u2 = 0;
      for (i = 1; i <= 10; i++)
	{
	  printf ("Unit %d ::Input %d von unit %d\n", unit, i, in_u[unit][i]);
	  if (in_u[unit][i] != unit)
	    {
	      if (i <= (int) par[unit][2])
		u++;
	      else
		u2++;

	    }
	}
      printf ("u %d u2 %d par[unit][2]=%d\n", u, u2, (int) par[unit][2]);
/*  shared_float_data */
      shared_float_data = malloc_1float (u * par[unit][5] + 10);
      if (0)
	{
	  printf ("u=%d\n", u);
	  exit (0);
	}



      if ((shidfdata =
	   shmget (keyfloat, sizeof (float) * ((int) ((u + u2) * nN + 10)),
		   IPC_CREAT | 0666)) < 0)
	{
	  printf ("shmget %d\n", shidfdata);
	  perror ("shmget fdata in ogltest ");
	  exit (1);
	}
      if ((fdata = shmat (shidfdata, NULL, 0)) == (int *) -1)
	{
	  perror ("shmat fdata");
	  exit (1);
	}
      shared_float_data = fdata;
/*  shared_float_data */

      param[0] = -1;
      param[7] = u2;
      param[1] = u;
      param[2] = par[unit][7];
      param[3] = par[unit][3];
      param[4] = par[unit][4];
      param[5] = par[unit][5];
      param[6] = par[unit][6];
      
      ax = 2 / ((float) (param[4] - param[3]));
      tx = -1 + ax * param[3];
      ax2 = 2 / ((float) (param[6] - param[5]));
      tx2 = -1 + ax2 * param[5];

      ogl_flag = 0;

      shared_data = shmdata;
      countmax = 24.0 * 3600.0 / ((double) nN);
      shared_data[0] = 123.0;
      shared_data[1] = 99123.0;
      shared_data[7] = countmax;
      shared_data[8] = 0.0;
      if ((plotter = (FILE *) popen ("OpenGL_Plotter", "w")) == NULL)
	exit (-1);
    }				/*end of ogl_flag */
/*--------------------------------------------------------------*/
  count += h;

  if (count > countmax)
    {
      shared_data[8] = tsim;
      for (i = 0; i < u; i++)
	{
	  for (j = 1; j < nN; j++)
	    {
	      fdata[(i) * nN + j] = fdata[(i) * nN + j + 1];
	    }			/*tausch */
	  fdata[(i + 1) * nN] = tx + ax * out_n[in_u[unit][i + 1]]
	    [in_nr[unit][i + 1]];
	}
      for (i = par[unit][2]; i < par[unit][2] + u2; i++)
	{

	  for (j = 1; j < nN; j++)
	    {
	      fdata[(i) * nN + j] = fdata[(i) * nN + j + 1];
	    }			/*tausch */
	  fdata[(i + 1) * nN] = tx2 + ax2 * out_n[in_u[unit][i + 1]]
	    [in_nr[unit][i + 1]];
	  /*printf("ogl %.4e \n",fdata[(i+1)*nN]); */
	}


      count = count - countmax;
    }

  if (param[0] == 2)
    {
      param[0] = 0;
    }

  if (param[0] == 3)
    {
      par[unit][1] = 0;
      shmctl (shidfdata, IPC_RMID, 0);
      shmctl (shidparam, IPC_RMID, 0);
      shmctl (shiddata, IPC_RMID, 0);
    }				/*quit plotter delete shm */
  while (param[0] == 0)
    {
      sleep (.5);
    }

  shared_data[9] = tsim;

/*bergabe der Inputs von Units*/
  for (i=1;i<=u;i++) {
   shared_data[9+i] = out_n[in_u[unit][i]][in_nr[unit][i]];
                    }
  for (i=u+1;i<=u+u2;i++) {
   shared_data[9+i] = out_n[in_u[unit][i]][in_nr[unit][i]];
                    }

/*bergabe der Inputs von pump*/
  shared_data[21] = out_n[in_u[unit][11]][in_nr[unit][11]];
  shared_data[22] = out_n[in_u[unit][12]][in_nr[unit][12]];
/*weitere punkte*/
  for (i = 1; i <= 2 * (int) par[unit][9]; i++)
    {
      shared_data[22 + i] = out_n[in_u[unit][12 + i]][in_nr[unit][12 + i]];
    }

/*
if (0) printf("OGL -> %5.4e  %5.4e\n",shared_data[21],shared_data[22]);
if (0) printf("max_ogl %d %d %d **%8.5f \n",unit,in_u[unit][1],in_nr[unit][1],input1);
*/

/*printf("tsim:%5.3f OGL -> %5.4e  %5.4e\n",tsim,
          out_n[  in_u[unit][11] ][ in_nr[unit][11]],out_n[  in_u[unit][12] ][ in_nr[unit][12] ]); 
*/
  return (1);
}

		/*-------------------------------------------------------------------*/
