
/*
   ColSim config.c
gcc -o config config.c
config default.cfg
*/
/*       10        20        30        40        50        60        70       */
/*3456789012345678901234567890123456789012345678901234567890123456789012345671*/
/*----------------------------------------------------------------------------*/
/* 
'config system.cfg' first read out default.cfg and creates object_list and
it's symbolik links. if filename system.cfg is not default.cfg, it reads
out system.cfg and completes the object list. the running config object list
is written ro the file running_config.cfg to check the necessity of a new
configuation. if running config equals with the the new config obkect list,
config is exiting with return 1;

following files should be created by config:
global.orig.h     --> ../src/global.h
type_call.orig.c  --> ../src/type_call.c
                      ../src/makefile
                      ../src/unit_order_init.h #hydraulic_type[]
                                               #priority[]

000414 NAME_LENGHT resized from 60 up to 100
000605 cfg-try_link added ( e.g.: try20 projects/valid_twd/try20)
000726 backup old files option
001023 return values defined for ColSim bash script
010307 create_global_header: 'int wall(' or 'int wall ('
011130 try_number check , only one symb link check
*/ 

#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_OBJECTS   100
#define NAME_LENGHT   100
#define type_object   3
#define kernel_object 2

int main(argc,argv)
 int   argc;
 char **argv;
{
int a=0; /* chriwi's debug */
FILE *file;
char filename[NAME_LENGHT];
char object     [MAX_OBJECTS][NAME_LENGHT];
char object_link[MAX_OBJECTS][NAME_LENGHT];
char line[300],str[4][100];
int i_object=0,i=0,i1=0;
int i_substitude=0;
int object_type[MAX_OBJECTS];
char function_call[MAX_OBJECTS][1000]; /* !! used in par-list */
int type_nr[MAX_OBJECTS]; /* read of the type number from source comment */
int priority[MAX_OBJECTS]; /* read out for unit_order */
int hydraulic_type[MAX_OBJECTS]; /* used to define set_init_mp */
char try_string[40]="\0",try_link[80]="\0";
int ret=0;



if (argc>1) /*  arguments 1:config 2:option1 ... */
 {
 printf("usage: config: configure ColSim system\n");
 printf("       config system.cfg  \n");
 printf("       creates makefile, global.h  and type_call.c routine  \n");
 if (a) printf("arg1=%s\n",argv[1]);
 if (a) printf("arg2=%s\n",argv[2]); 
 if (strstr(argv[1],"-d")!=NULL) a=1;
 if (argc>2) exit(0);
 sprintf(filename,"%s",argv[1]); /* get config filename */
 if (a) printf("filename:%s\n",filename);
 }

/* init array's */
for (i=0;i<MAX_OBJECTS;i++) type_nr[i]=priority[i]=hydraulic_type[i]=0;

/* fst read out config.cfg */
if (a) printf("config: filename:%s\n",filename);
if ((file=fopen("default.cfg","r"))==NULL) /* open config file */
 { printf("filename error: %s \n",filename);exit (-1); }

while (fgets(line,300,file)!=NULL) /* read configure lines */
 {
 if (   (line[0]=='#') || (line[0]==' ')  || (line[0]=='\t' )
     || (line[0]==0x0d) || (line[0]==0x0a) ) continue;
 sscanf(line,"%s %s %s",str[0],str[1],str[2]);
 if (strstr(str[0],".c")!=NULL) {  /* check extension '.c' */
   sprintf(object[i_object],"%s",str[0]); 
   object[i_object][strlen(object[i_object])-2]='\0'; /* cut .c */
   }
 if (strstr(str[1],".c")!=NULL) {  /* check extension '.c' */
   sprintf(object_link[i_object],"%s",str[1]); 
   object_link[i_object][strlen(object_link[i_object])-2]='\0';
   }
 if (strstr(str[2],"TYPE")!=NULL) /* print if Type */
   {
   object_type[i_object]=type_object;
   }
 else object_type[i_object]=kernel_object;
 if (a) printf("%d: obj:%20s \t link:%30s \ttype:%d\n"
               ,i_object,object[i_object],object_link[i_object],object_type[i_object]);
 i_object++;
 }; /* end read lines */
fclose(file); /* end of read out default.cfg */

/* look for the filename of command line to extend object list */
/* second read out of configuation file2  counting further with i_object */
/* object list which is created is size(default) + size(system)  */
/* later in type_sorting process double typenumbers are substituded */
if (strstr(filename,"default.cfg")==NULL)  /* config file is filename.cfg */
  {
  if (a) printf("2nd read out config-file:%s is not default.cfg \n",filename);
  if ((file=fopen(filename,"r"))==NULL) /* open config file */
   { printf("main: exit: filename error: %s \n",filename);exit (-1); }

  while (fgets(line,300,file)!=NULL) /* read configure lines */
   {
   if (   (line[0]=='#') || (line[0]==' ')   /* chaeck valid line in cfg file */
       || (line[0]==0x0d) || (line[0]==0x0a) ) continue;
   sscanf(line,"%s %s %s",str[0],str[1],str[2]);
   if (strstr(str[0],"try")!=NULL) {  /* check weather link */
     if (try_string[0]!='\0') { printf("config:more than one tryXX links,exit\n");
       exit (-1); }
     sprintf(try_string,"%s",str[0]); /* 'try' from 1st word */
     sprintf(try_link  ,"%s",str[1]); /* link from 2nd word */
     continue; /* skip loop, read next line */
     }
  if (strstr(str[0],".c")!=NULL) {  /* check extension '.c' */
   sprintf(object[i_object],"%s",str[0]); 
   object[i_object][strlen(object[i_object])-2]='\0';
   }
  if (strstr(str[1],".c")!=NULL) {  /* check extension '.c' */
   sprintf(object_link[i_object],"%s",str[1]); 
   object_link[i_object][strlen(object_link[i_object])-2]='\0';
   }
  if (strstr(str[2],"TYPE")!=NULL) /* print if Type */
   {
   object_type[i_object]=type_object;
   }
  else object_type[i_object]=kernel_object;
  if (a) printf("%d: obj:%20s \t link:%30s \ttype:%d\n"
               ,i_object,object[i_object],object_link[i_object],object_type[i_object]);
  i_object++;
  }; /* end read lines */
  fclose(file); /* end of read out system.cfg */
 } /* end reading filename config */

/* check object names: if new config has different symbolic links to
   more_types etc, eleminate object from default_list by rewriting
   object with 2nd object (object,object_link,object_type)
   if a new type appears in src-path add thisone to the object list;
   later a makefile should check type numbers */
if (a) printf("\neleminate double symbolik links:\n");
if (a) for (i=0;i<i_object;i++) printf("object:%d object:%20s object_link:%30s\n",
             i,object[i],object_link[i]);

for (i=0;i<i_object;i++) {
 if (a) printf("i_object:%d object:%s object_link:%s type:%d\n",
        i,object[i],object_link[i],object_type[i]); 
 for (i1=i+1;i1<i_object;i1++)
  if (   (strstr(object[i],object[i1])!=NULL)  /* equal object name */
      && (strlen(object[i])==strlen(object[i1]) ) /* equal lenght */
     )
     {
     if (a) printf("##move 2nd object to fst:####### %d:%s = %d:%s \n"
                   ,i, object[i],i1,object[i1]);
     sprintf(object     [i],"%s",object     [i1]); sprintf(object     [i1],"\0"); 
     sprintf(object_link[i],"%s",object_link[i1]); sprintf(object_link[i1],"\0");
     object_type        [i]     =object_type[i1];  object_type        [i1]=0;
     }
 } /* run through all objects */
if (a) for (i=0;i<i_object;i++) printf("object:%d object:%20s object_link:%30s\n",
             i,object[i],object_link[i]);
/* re-order object list: may be there are some spaces in the object list */
if (a) printf("\nrenumber object list:\n");
/* searching spaces in object list */
i_substitude=0;
for (i=0;i<i_object;i++) { if (object[i][0]=='\0') i_substitude++; }
for (i=0;i<i_object;i++) {
 if (object[i][0]=='\0') /* on empty object name , get next valid object */
    { 
    i1=i; do { i1++; } while ( (object[i1][0]=='\0') && (i1<i_object) );
    if (i1<i_object) 
      { 
      /* i_substitude++; / * inc number of i_substituded objects */
      if (a) printf("substitude object[%d]:%s with: object[%d]:%s i_substitude:%d\n"
                    ,i,object[i],i1,object[i1],i_substitude);
      sprintf(object     [i],"%s",object     [i1]); sprintf(object     [i1],"\0");
      sprintf(object_link[i],"%s",object_link[i1]); sprintf(object_link[i1],"\0");
      object_type        [i]     =object_type[i1];  object_type        [i1]=0;
      }
    else { if (a) printf("i1:%d %s \n",i1,object[i]); }
    }
 } /* run through all objects */
printf("i_object:%d i_substitude:%d\n",i_object,i_substitude);
i_object-=i_substitude; /* rewrite number of objects */
if (a) for (i=0;i<i_object;i++) printf("%d: obj:%20s \t link:%30s \ttype:%d\n"
               ,i,object[i],object_link[i],object_type[i]);
printf(" %d objects where %d are substituded \n",i_object,i_substitude); 

ret=create_running_config(i_object,(char**) object,
                     (char**) object_link, (int *) object_type);
if (ret==0) printf("create_running_config returns 0 exit:-1 \n");
if (ret==0) return (3); 

create_symbolic_links(i_object,(char**) object,
                     (char**) object_link, (int *) object_type
                   ,(char*) try_string,(char*) try_link);

create_makefile(i_object,(char**) object); 
create_global_header(i_object,(char**) object,(int *) object_type,
                     (char**) function_call,(int*) type_nr,(int*) priority
                    ,(int*) hydraulic_type);

create_type_call_routine(i_object,(char**) object,(int *) object_type,
                     (char**) function_call,(int*) type_nr,(int*) priority
                    ,(int*) hydraulic_type);
printf("create_type_call_routine written\n");

create_unit_order_init(i_object,(char**) object,(int *) object_type,
                     (char**) function_call,(int*) type_nr,(int*) priority
                    ,(int*) hydraulic_type);
/*
printf("function_call:%s\n",function_call[20]);
printf("type_nr:%d\n",type_nr[20]);
printf("priority:%d\n",priority[20]);
printf("hydraulic_type:%d\n",hydraulic_type[20]);
*/

/* create_type_call.c */
/* BEGIN and END patterns in src/type_call.orig.c */

return (1);
}
/*----------------------------------------------------------------------------*/

int create_running_config(int NumberOfObjects,
                          char ObjectNames    [MAX_OBJECTS][NAME_LENGHT],
                          char ObjectNamesLink[MAX_OBJECTS][NAME_LENGHT],
                          int object_type[MAX_OBJECTS])
{
int a=0; /* chriwi's debug */

FILE *file;
char filename[NAME_LENGHT];
char command[200];
int i;
int  NumberOfObjectsPrevious=0; /* last running config */
char ObjectNamesPrevious    [MAX_OBJECTS][NAME_LENGHT];
char ObjectNamesPreviousLink[MAX_OBJECTS][NAME_LENGHT];
int  NumberMax; /* max(NumberOfObjectsPrevious,NumberOfObjects) */
int ready;
int skip=0;
char line[300],str[4][100];

/* read out 'running_config.cfg' to get former  object_list, if no file
   exits, skip=1 for skipping comparing process (running_config.cfg/
   system.cfg) 
*/
if (a) printf("test old config\n");
sprintf(filename,"%s","running_config.cfg");
if ((file=fopen(filename,"r"))==NULL)
  { printf("no file:%s configure ... \n",filename);
    skip=1;     /* skip reading old config */ 
  }

if (!skip)
{
if (a) printf("create_running_config: file 'running_config.cfg' exists\n");
/* run through type_call.orig.c and copy thisone to type_call.c */
ready=0;
i=0; /* count number of objects in 'running_config.cfg' */
while ( (!ready) && (fgets(line,300,file)!=NULL) )
 {
  if (strstr(line,".c")!=NULL) 
   {
   sscanf(line,"%s %s %s",str[0],str[1],str[2]);
   sprintf(ObjectNamesPrevious    [i],"%s",str[1]);
   ObjectNamesPrevious[i][strlen(ObjectNamesPrevious[i])-2]='\0'; /* without extension */
   sprintf(ObjectNamesPreviousLink[i],"%s",str[2]);
   ObjectNamesPreviousLink[i][strlen(ObjectNamesPreviousLink[i])-2]='\0';
   if (a) printf("%d:%20s.c %20s.c \n",i,ObjectNamesPrevious[i],ObjectNamesPreviousLink[i]);
   i++;
   /* if (a) printf("%s: %20s \t%20s \n",filename,str[1],str[2]); */
   }
 }
fclose(file); /* close running_config.cfg file  */

NumberOfObjectsPrevious=i;
if (NumberOfObjectsPrevious>NumberOfObjects) NumberMax=NumberOfObjectsPrevious;
else                                         NumberMax=NumberOfObjects;

if (a) printf("test running_config.cfg/thisconfig.cfg: NumberOfObjects:%d/:%d \n"
              ,NumberOfObjects,NumberOfObjectsPrevious);
for (i=0;i<NumberMax;i++) /* run through object list */
 {
 if  (  (strstr(ObjectNamesPrevious[i],ObjectNames[i]) == NULL)  /* check objects */
      ||(strlen(ObjectNamesPrevious[i])!=strlen(ObjectNames[i]) )
     )
   {
   printf("Config has changed:\n");
   if (ObjectNames[i]!='\0') printf("ObjectNames[%d]:%20s in current config \n",i,ObjectNames[i]);
   else                      printf("ObjectNames[%d]:%20s in last    config \n"
                                    ,i,ObjectNamesPrevious[i]);
   skip=1;   
   }
 if (  (strstr(ObjectNamesPreviousLink[i],ObjectNamesLink[i]) == NULL) 
     ||(strlen(ObjectNamesPreviousLink[i])!=strlen(ObjectNamesLink[i]) ) /* check link */
    )
   {
   printf("Config has changed due to symbolik link:\n");
   if (ObjectNamesLink[i]!='\0') printf("ObjectNamesLink[%d]:%20s in current config \n"
                                        ,i,ObjectNamesLink[i]);
   else                          printf("ObjectNamesLink[%d]:%20s in last    config \n"
                                        ,i,ObjectNamesPreviousLink[i]);
   skip=1;    
   }
 }
if (NumberOfObjects!=NumberOfObjectsPrevious) skip=1; /* configure */
if (!skip) {
 printf("\nconfig has not changed (running_config.cfg), ... exit   \n");
 return(0);
 }
} /* if !skip */

if (a) printf("create_running_config:\n");
sprintf(filename,"%s","running_config.cfg");
if ((file=fopen(filename,"w"))==NULL)
  { printf("create_running_config: exit: filename error: %s \n",filename);
    exit (-1); 
  }
for (i=0;i<NumberOfObjects;i++) /* run through object list */
 {
 if (a) printf("ObjectNames[%d]:%20s.c \t%20s.c\n"
   ,i,ObjectNames[i],ObjectNamesLink[i]);
 fprintf(file,"ObjectNames[%d]: %20s.c \t%20s.c\n",i,ObjectNames[i],ObjectNamesLink[i]); 
 }
fclose(file);

return(1);
} /* end of create_running_config() */

/*----------------------------------------------------------------------------*/
int create_type_call_routine(int NumberOfObjects,
                         char ObjectNames[MAX_OBJECTS][NAME_LENGHT],
                         int object_type[MAX_OBJECTS],
                         char function_call[MAX_OBJECTS][1000],
                         int type_nr[MAX_OBJECTS],
                         int priority[MAX_OBJECTS],
                         int hydraulic_type[MAX_OBJECTS]
                        )
{
int a=0; /* chriwi's debug */
FILE *file,*file_destination;
char filename[NAME_LENGHT],filename_destination[NAME_LENGHT];
char line[300];
char str[4][100];
char parameter_list[4000],dummy[4000];
char parameter_declaration[4000]; /* e.g. double **out_n,int init_flag */
char *string_ptr;
int i,i1,i3;
int proof=0;
int ready=0;
int lower_type=0; /* used to sort type order for function calls */
int lower_type_pos=0;
#define MAX_TYPES 200
int type_selection[MAX_TYPES]; /* proof , if double types */
int type_sorting[MAX_TYPES];

/* read out header file from global.orig.h */
sprintf(filename,"%s","type_call.orig.c");
if ((file=fopen(filename,"r"))==NULL)
 { printf("create_type_call_routine: exit: filename error: %s \n",filename);exit (-1); }
sprintf(filename_destination,"%s","../src/type_call.c"); /* PATH */
if ((file_destination=fopen(filename_destination,"w"))==NULL)
 { printf("create_type_call_routine: exit: filename error: %s \n",
            filename_destination);exit (-1); }
/* run through type_call.orig.c and copy thisone to type_call.c */
ready=0;
while ( (!ready) && (fgets(line,300,file)!=NULL) ) 
 {
 fprintf(file_destination,"%s",line);
 if ( ( strstr(line,"BEGIN")!=NULL ) && ( strstr(line,"CASE_LOOP")!=NULL ) ) ready=1;
 if (a) printf("%s: %s",filename,line);
 }
fclose(file); /* type_call.orig.c */
/* fclose(file_destination); */
/* type sorting -------------------------------------------------------------*/
/* check double existance of type and sort types 1..n */
for (i=0;i<MAX_TYPES;i++) type_selection[i]=0; /* reset */
for (i=0;i<MAX_OBJECTS;i++) 
  if (type_nr[i]>0) 
     {
     type_selection[type_nr[i]]++;
     if (type_selection[type_nr[i]]>1) { /* check double existance */
       for (i1=0;i1<=i;i1++) 
         if (object_type[i]==type_object) 
           printf("ObjectNames[i_object:%d]:%30s.c \tTYPE:%d \n"
                  ,i1,ObjectNames[i1],type_nr[i1] );
       printf("create_type_call_routine: multiple type definition in "
        "ObjectNames[i_object:%d]:%s.c TYPE:%d \n"
        ,i,ObjectNames[i],type_nr[i] ); exit (-1);
       }
    } /* type found */

for (i=0;i<MAX_OBJECTS;i++) /* list all types with its selection number */
 if (type_selection[type_nr[i]]!=0) if (a) printf("########type_selection[%d]:%20s \t %.1d \n"
      ,i,ObjectNames[i],type_selection[ type_nr[i] ]);
/* sort types for the function calls */
i3=0; /* index in type_sorting array, wher the object number is stored */
for (i=0;i<NumberOfObjects;i++) type_selection[i]=0; /* reset selection */

for (i=0;i<NumberOfObjects;i++) { /* first loop */
  lower_type_pos=0;lower_type=MAX_TYPES;
  for (i1=0;i1<NumberOfObjects;i1++) /* 2nd loop */
    {
    if ( (object_type[i1]==type_object) && (type_selection[i1]==0) ) {
      if (a) printf(":::::::: %d: type_nr[%s.c]=%d \t select:%d \n"
            ,i1,ObjectNames[i1],type_nr[i1],type_selection[i1]);
      if (type_nr[i1]<lower_type) {lower_type=type_nr[i1]; lower_type_pos=i1;}
      }
    } /* end 2nd loop */
  type_selection[lower_type_pos]=1; /* lower_type_pos = [0..NumberOfObjects] */
  if (lower_type!=MAX_TYPES)
    {
    if (a) printf("###############lower_type:%d lower_type_pos:%d \n"
           ,lower_type,lower_type_pos);
    type_sorting[i3]=lower_type_pos;i3++;type_sorting[i3]=0;
    }
  } /* first loop */

for (i=0;i<i3;i++) {
  if (a) printf("type_sort: type_sorting[%d]:%d \ttype:%d \n" 
                ,i,type_sorting[i], type_nr[type_sorting[i]] );
  }
/*  end type sorting ---------------------------------------------------------*/
/*
i=0; do { if (a) printf("type_sort: type_sorting[%d]:%d \ttype:%d \n" 
                  ,i,type_sorting[i], type_nr[type_sorting[i]] );
   } while (  (type_sorting[i++]!=0) && (i>1) ) ;
*/
/* sorted type sequence in type_sorting[] with the i_object number */

i=0; do { if (a) printf("function_call: type:%d %s\n",type_nr[type_sorting[i]]
                  ,function_call[ type_sorting[i] ]);
          fprintf(file_destination," case %d: /* TYPE */ \n     check=%s\n"
                  ,type_nr[type_sorting[i]],function_call[ type_sorting[i] ]); 
          fprintf(file_destination,"     break;\n");
          i++;
   } while (i<i3); /* (type_sorting[i++]!=0); */

/* write end of file type_call(); */
fprintf(file_destination,"  default:\n");

str[0][0]='%';str[0][1]='\0';
fprintf(file_destination,"       printf(\"unknown TYPE:%sd unit:%sd exit\\n\""
                                        ",type[unit],unit);exit (-1);\n"
                                  ,str[0],str[0]);
fprintf(file_destination,"     } /*case-end*/\n");
fprintf(file_destination,"\n\nreturn (check);\n}\n /* end of type_call() */");

fclose(file_destination); 
/*
  case 14:
     check=load(unit,tsim,par,out_o,out_n,day_of_year,day_of_week);
     break;

*/

return(1);
} /* create_type_call_routine */
/*----------------------------------------------------------------------------*/

int create_symbolic_links(int NumberOfObjects,
                          char ObjectNames    [MAX_OBJECTS][NAME_LENGHT],
                          char ObjectNamesLink[MAX_OBJECTS][NAME_LENGHT],
                          int object_type[MAX_OBJECTS],
                          char* try_string,char* try_link)
{
int a=1; /* chriwi's debug */

FILE *file;
char filename[NAME_LENGHT];
char command[200];
int i;
int backup=0; /* backup old files */

if (a) if (a) printf("create_symbolic_links:\n");
for (i=0;i<NumberOfObjects;i++) /* run through object list */
 {
 if (    (1) /* object_type[i]==type_object)  check type-status and link status */
      && (strstr(ObjectNamesLink[i],"more_types")!=NULL)   /* now '/' */
      || (strstr(ObjectNamesLink[i],"project"   )!=NULL) 
    )
    {
    if (a) printf("ObjectNames[%d]:%20s.c \t%20s.c\n"
            ,i,ObjectNames[i],ObjectNamesLink[i]);

    /* make backup of files to link to more_types */
    sprintf(command,"cp ../src/%s.c ../src/bak/%s.c"
               ,ObjectNames[i],ObjectNames[i]);
    if (backup) 
     {
     if ( ( file= (FILE*) popen(command,"w")) == NULL) { printf("popen errer \n"); 
                                                        exit (-1); }
     if (a) printf("command:%s ...executed \n",command);
     fflush (file);
     fclose(file);
     }
    /* create symbolic link to more_types */
    sprintf(command,"ln -s -f ../%s.c ../src/%s.c"
                    ,ObjectNamesLink[i],ObjectNames[i]);
    if ( ( file= (FILE*) popen(command,"w")) == NULL) { printf("popen errer \n"); 
                                                        exit (-1); }
    if (a) printf("command:%s ...executed \n",command);
    fflush (file);
    fclose(file);
    }
 }
/* create symbolic link special weather data */
if (strstr(try_string,"try")!=NULL) {  /* check weather link */
 char dummy_string[30],*rest;
 int i3,try_number;
 sprintf(dummy_string,"%s",try_string);
 for (i3=0;i3<strlen(dummy_string);i3++) 
  if ( (dummy_string[i3]<0x30) || (dummy_string[i3]>0x39) ) dummy_string[i3]=' ';
 try_number=(int) strtod(dummy_string,&rest);
 if (a) printf("try_number:%d try_string:%s\n",try_number,try_string);
 if (try_number<=13) { printf("error link to default try's, select number >13!\n:%s\n",
  try_string); exit (-1); }
 if (a) printf(command,"ln -s ../%s ../weather/%s" ,try_link,try_string);
 sprintf(command,"rm ../weather/%s ; ln -s ../%s ../weather/%s" 
   ,try_string,try_link,try_string);
 if ( ( file= (FILE*) popen(command,"w")) == NULL) { printf("popen errer \n"); 
                                                        exit (-1); }
 if (a) printf("command:%s ...executed \n",command);
 fflush (file);
 fclose(file);
 }
if (a) printf("try_string:%s try_link:%s \n", try_string,try_link);

return(1);
}

/*----------------------------------------------------------------------------*/
int create_global_header(int NumberOfObjects,
                         char ObjectNames[MAX_OBJECTS][NAME_LENGHT],
                         int object_type[MAX_OBJECTS],
                         char function_call[MAX_OBJECTS][1000],
                         int type_nr[MAX_OBJECTS],
                         int priority[MAX_OBJECTS],
                         int hydraulic_type[MAX_OBJECTS]
                        )
{
int a=0; /* chriwi's debug */
FILE *file,*file_destination;
char filename[NAME_LENGHT],filename_destination[NAME_LENGHT];
char line[300];
char str[4][100];
char parameter_list[4000],dummy[4000];
char parameter_declaration[4000]; /* e.g. double **out_n,int init_flag */
char *string_ptr;
int i,i1;
int proof=0;
int ready=0;

/* read out header file from global.orig.h */
sprintf(filename,"%s","global.orig.h");
if ((file=fopen(filename,"r"))==NULL)
 { printf("create_global_header: exit: filename error/file not existant: %s \n"
          ,filename);exit (-1); 
 }
sprintf(filename_destination,"%s","../src/global.h"); /* PATH */
if ((file_destination=fopen(filename_destination,"w"))==NULL)
 { printf("create_global_header: exit: filename_destination error: %s \n",
            filename_destination);exit (-1); }
/* run through global.orig.h and copy thisone to global.h */
while (fgets(line,300,file)!=NULL)
 {
 fprintf(file_destination,"%s",line);
 if (0) printf("%s: %s",filename,line);
 }
fclose(file); /* global.orig.h */

/* get function calls out of object list */
for (i=0;i<NumberOfObjects;i++) 
 {
 parameter_list[0]='\0';
 parameter_declaration[0]='\0';
 dummy[0]='\0';
 if (a) printf("object_type[%d]:%d type_object:%d ObjectNames:%s\n",
        i,object_type[i],type_object,ObjectNames[i]);
 if ( (object_type[i]==type_object)  /* find type object */
      && (strlen(ObjectNames[i])!=0)
     /* && ( strstr(ObjectNames[i],         "zone")!=NULL ) 
       && ( strlen(ObjectNames[i])==strlen("zone") )
     */
    )
  {
  if (a) printf("create_global_header: %d:%s \ttype_object\n",i,ObjectNames[i]);
  sprintf(filename,"../src/%s.c",ObjectNames[i]);
  if ((file=fopen(filename,"r"))==NULL)
    { printf("create_global_header: exit: filename error/file not existant: %s \n"
      ,filename);exit (-1); 
    }
  proof=0;ready=0;
  while ( (!ready) && (fgets(line,300,file)!=NULL)  )
    {
    sscanf(line,"%s %s %s",str[0],str[1],str[2]);
    if ( strstr(str[0],"int")!=NULL ) { /* serach fst word 'int' */
     proof=1;
     for (i1=0;i1<strlen(ObjectNames[i]);i1++)  /* check chars of ObjectName */
      { 
      if (str[1][i1]==ObjectNames[i][i1]) proof&=proof;
      else                                proof=0;
      }
     if (  (str[1][strlen(ObjectNames[i])]==' ') /*'int wall(' or 'int wall ('*/
         ||(str[1][strlen(ObjectNames[i])]=='(')
         ||(str[1][strlen(ObjectNames[i])]=='\0')) proof&=proof;
     else                                          proof=0;
     }
    if (proof) { ready=1; if (a) printf("%s: %s",filename,line); }
    }
   /* get parameter_list between brackets */
   string_ptr=strstr(line,ObjectNames[i]); /* go to pattern */
   if (a) printf("i:%d ObjectNames:%s\n",i,ObjectNames[i]);
   if (string_ptr==NULL) { printf("object i:%d error finding ObjectNames:%s %d\n"
                                 ,i,ObjectNames[i],NumberOfObjects); exit (-1); }
   string_ptr+=strlen(ObjectNames[i]);
   i1=0;
   do
     { 
     parameter_list[i1++]=*string_ptr++;
     } while ( *string_ptr != '\0' ); 
   parameter_list[i1-1]='\n';
   parameter_list[i1  ]='\0';

   if (strstr(parameter_list,")")!=NULL )  /* search end of par-list */
     {
     i1=0;
     while (parameter_list[i1]!=')') i1++;
     parameter_list[i1+1]='\0';
     }
   else /* parameter_list seems to be longer than this line */
     {
     ready=0;
     while ( (!ready) && (fgets(line,300,file)!=NULL)  )
      {
      if (strstr(line,")")!=NULL ) ready=1; /* break on close bracket */
      sprintf(dummy,"%s",parameter_list);
      sprintf(parameter_list,"%s%s\0",dummy,line);
      }
     }
  if (parameter_list[strlen(parameter_list)-1]==0x0a)
      parameter_list[strlen(parameter_list)-1]='\0';
  if (a) printf("function_call:%s %s;\n",ObjectNames[i],parameter_list);
  /*
  sprintf(function_call[i],"\nint %s %s;\n",ObjectNames[i],parameter_list);
  */
  sprintf(function_call[i],"%s %s;",ObjectNames[i],parameter_list);
  
  /* read out command line ready, now try to find declaration of parameters */
  /* parameter declation must start in a new line and an '{' has to follow */
  ready=0;
  sprintf(dummy,"\0");
  while ( (fgets(line,300,file)!=NULL) && (!ready) )
    {
    if (strstr(line,"{")!=NULL ) { ready=1; continue; }/* break on close bracket */
    sprintf(dummy,"%s",parameter_declaration);
    sprintf(parameter_declaration,"%s%s\0",dummy,line);
    }
  if (a) printf("\nparameter_declaration:%s\n",parameter_declaration);
   /* substitude ';' to ',' for function declaration in global.h */
  i1=0; do { if (parameter_declaration[i1]==';') parameter_declaration[i1]=',';
             i1++; } 
        while (i1<strlen(parameter_declaration)) ;
  i1=strlen(parameter_declaration); /* erase last ',' */
  do { i1--; } while ( (parameter_declaration[i1]!=',') && (i1>0) );
  if    (parameter_declaration[i1]  ==',') parameter_declaration[i1]=' ';

  if (a) printf("\nparameter_declaration:%s\n",parameter_declaration);
  /* write out declaration for global.h */
  fprintf(file_destination,"\nint %s(\n%s);\n",ObjectNames[i],parameter_declaration);
/*
  fprintf(file_destination,"\nint %s%s\n",ObjectNames[i],parameter_list);
  fprintf(file_destination,"%s\n",parameter_declaration);
*/
  /* end of declaration and function_call extraction */
  ready=0;
  sprintf(dummy,"\0");
  while ( (fgets(line,300,file)!=NULL) && (ready<3) )
    {
    sscanf(line,"%s %s %s",str[0],str[1],str[2]);
    if (strstr(str[0],"TYPE")!=NULL )  { 
      ready++; 
      type_nr[i]=(int) strtod(str[1],NULL);
      };
    if (strstr(str[0],"PRIORITY")!=NULL )  { 
      ready++; 
      priority[i]=(int) strtod(str[1],NULL);
      };
    if (strstr(str[0],"HYDRAULIC")!=NULL )  { 
      ready++; 
      hydraulic_type[i]=(int) strtod(str[1],NULL);
      };
    if (0) printf("ready:%d\n",ready);
    }
  if (a) printf("type_nr:%d priority:%d hydraulic_type:%d\n",
          type_nr[i],priority[i],hydraulic_type[i]);
  if (   (type_nr[i]==0) || (priority[i]==0) || (hydraulic_type[i]==0) )
    { printf("filename:%s.c error in TYPE:%d / PRIORITY:%d / HYDRAULIC: "
             "%d definition \n"
             ,ObjectNames[i],type_nr[i],priority[i],hydraulic_type[i]);
      exit (-1);
    }
     
  fclose(file); /* ObjectNames */

  } /* object_type found */
 else if (0) printf("no object with type flag :%d \n",i);
 } /* end run through NumberOfObjects */

fclose(file_destination); /* global.orig.h */
return(1);
} /* create_global_header */


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
int create_makefile(int NumberOfObjects,char ObjectNames[MAX_OBJECTS][NAME_LENGHT])
{
int a=0; /* chriwi's debug */

FILE *file;
char filename[NAME_LENGHT];
int i;
char makefile_header[200]={"# makefile ColSim generated by cfg/config "};
char makefile_gcc[30]    ={"CC \t =gcc"};
char makefile_libs[30]   ={"LIBS \t =-lm # -lefence "};
char makefile_opts[30]   ={"OPTS \t =-g -Wall #-pg -ansi "};
char makefile_first_command[2000]={"sim: \t"};
char dummy[2000];
int lenght=0;


for (i=0;i<NumberOfObjects;i++) if (a) printf("create_makefile: %d:%s\n",i,ObjectNames[i]);

for (i=0;i<NumberOfObjects;i++)  /* create string makefile_first_command */
   {
   if (strlen(ObjectNames[i])>1) /* if not empty */
    {
     sprintf(dummy,"%s",makefile_first_command);
     sprintf(makefile_first_command,"%s%s.o \\\n\t",dummy,ObjectNames[i]);
    }
   }
lenght=strlen(makefile_first_command);
if (lenght>=2000) { printf(" makefile char size error:%d \n",lenght); exit (-1); }
makefile_first_command[lenght-3]='\0'; /* cut backslash and tab */

 /* create linker command */
sprintf(dummy,"%s",makefile_first_command);
sprintf(makefile_first_command,"%s\n\n\t$(CC) -o ../sim $(OPTS) \\\n\t",dummy); 

for (i=0;i<NumberOfObjects;i++)  /* create string makefile_first_command */
   {
   if (strlen(ObjectNames[i])>1) /* if not empty */
    {
    sprintf(dummy,"%s",makefile_first_command);
    sprintf(makefile_first_command,"%s%s.o \\\n\t",dummy,ObjectNames[i]);
    }
   }
lenght=strlen(makefile_first_command);
if (lenght>=2000) { printf(" makefile char size error:%d \n",lenght); exit (-1); }
makefile_first_command[lenght-3]='\0'; /* cut backslash and tab */

/* spacer to object definitions and add libs string */
sprintf(dummy,"%s",makefile_first_command);
sprintf(makefile_first_command,"%s $(LIBS) \n",dummy);

if (a) printf("makefile:\n");
sprintf(filename,"%s","../src/makefile"); /* PATH */
if ((file=fopen(filename,"w"))==NULL)
 { printf("create_makefile: exit: filename error: %s \n",filename);exit (-1); }

fprintf(file,"%s\n%s\n%s\n%s\n%s\n",makefile_header,makefile_gcc,makefile_libs
              ,makefile_opts,makefile_first_command);

if (a) printf("%s\n%s\n%s\n%s\n%s\n",makefile_header,makefile_gcc,makefile_libs
              ,makefile_opts,makefile_first_command);

for (i=0;i<NumberOfObjects;i++)  /* create string makefile_first_command */
   {
   if (strlen(ObjectNames[i])>1) /* if not empty */
    {
    if (a) printf("%s.o:\t%s.c global.h\n\t$(CC) -o %s.o $(OPTS) -c %s.c\n\n"
          ,ObjectNames[i],ObjectNames[i],ObjectNames[i],ObjectNames[i]);
    fprintf(file,"%s.o:\t%s.c global.h\n\t$(CC) -o %s.o $(OPTS) -c %s.c\n\n"
          ,ObjectNames[i],ObjectNames[i],ObjectNames[i],ObjectNames[i]);
    }
   }
fprintf(file,"\nclean:\t\n\trm -f core\n\trm *.o\n\n");
fclose(file);

if (a) printf("\nclean:\t\n\trm -f core\n\trm *.o\n\n");

return (1);
} /* create_makefile() */


/*----------------------------------------------------------------------------*/
int create_unit_order_init(int NumberOfObjects,
                         char ObjectNames[MAX_OBJECTS][NAME_LENGHT],
                         int object_type[MAX_OBJECTS],
                         char function_call[MAX_OBJECTS][1000],
                         int type_nr[MAX_OBJECTS],
                         int priority[MAX_OBJECTS],
                         int hydraulic_type[MAX_OBJECTS]
                        )
{
int a=0; /* chriwi's debug */
FILE *file_destination;
char filename_destination[NAME_LENGHT];
char *string_ptr;
int i,i1,i3;
#define MAX_TYPES 200
int type_sorting[MAX_TYPES];
int number_of_types;
int myTypeNumber=0;

number_of_types=type_sorting_routine(NumberOfObjects,ObjectNames,object_type,
                     function_call,type_nr,priority,hydraulic_type,type_sorting);
for (i=0;i<number_of_types;i++) if (a) printf("%2d: type_sorting[%d]:%2d \n"
                                  ,i,type_sorting[i],type_nr[type_sorting[i]]);

if (a) printf("\n");
for (i=0;i<number_of_types;i++)
 {
 while (type_nr[type_sorting[i]]>myTypeNumber)
   {
   if (a) printf("dummyType:myTypeNumber:%d\n",myTypeNumber);
   myTypeNumber++; 
   };
 if (a) printf("%2d: type_sorting[%d]:%2d myTypeNumber:%d\n"
        ,i,type_sorting[i],type_nr[type_sorting[i]],myTypeNumber);
 myTypeNumber=type_nr[type_sorting[i]]+1;
 }


sprintf(filename_destination,"%s","../src/unit_order_init.h"); /* PATH */
if ((file_destination=fopen(filename_destination,"w"))==NULL)
 { printf("create_unit_order_init: exit: filename error: %s \n",
            filename_destination);exit (-1); }
if (a) printf("create_unit_order_init:\n");
 
fprintf(file_destination,"/*unit_order.h created by cfg/config */\n");
fprintf(file_destination,"/*\n   this header is generated with config routine: it's used\n");
fprintf(file_destination,"   to define unit_order and set_init_mp hydraulic order\n*/\n\n");
fprintf(file_destination,"int priority[MAX_TYPES]={ \n");
fprintf(file_destination,"  /* type 0:                      */ 99,\n");

/*
for (i=0;i<NumberOfObjects;i++) 
 {
 if (a) printf("Object:%20s type:%2d priority:%2d hydraulic_type:%2d \n",
     ObjectNames[i],type_nr[i],priority[i],hydraulic_type[i]); 
 }
for (i=0;i<NumberOfObjects-1;i++) 
 fprintf(file_destination,"  / * type%2d: %20s * / %d,\n"   ,i,ObjectNames[i],priority[i]);
fprintf(file_destination, "  / * type%2d: %20s * / %d\n};\n",i,ObjectNames[i],priority[i]);
*/
/* type_sorted print */
for (i=0;i<number_of_types;i++)
 {
 while (type_nr[type_sorting[i]]>myTypeNumber)
   {
   if (a) printf("dummyType:myTypeNumber:%d\n",myTypeNumber);
   fprintf(file_destination,"  /* type%2d: %20s */ %d, \n"   ,myTypeNumber,"",99);
   myTypeNumber++;
   };
 if (i==number_of_types-1)
   fprintf(file_destination, "  /* type%2d: %20s */ %d,\n};\n" /* array end with '}' */
             ,type_nr[type_sorting[i]],ObjectNames[type_sorting[i]],priority[type_sorting[i]]);
 else
   fprintf(file_destination, "  /* type%2d: %20s */ %d,\n"
             ,type_nr[type_sorting[i]],ObjectNames[type_sorting[i]],priority[type_sorting[i]]);
 myTypeNumber=type_nr[type_sorting[i]]+1;
 }

/* create hydraulic_type[] array */
fprintf(file_destination,"\n\nint hydraulic_type[MAX_TYPES]={ \n");
fprintf(file_destination,"  /* type 0:                      */ 99,\n");
for (i=0;i<number_of_types;i++)
 {
 while (type_nr[type_sorting[i]]>myTypeNumber)
   {
   if (a) printf("dummyType:myTypeNumber:%d\n",myTypeNumber);
   fprintf(file_destination,"  /* type%2d: %20s */ %d,\n"   ,myTypeNumber,"",99);
   myTypeNumber++;
   };
 if (i==number_of_types-1)
   fprintf(file_destination, "  /* type%2d: %20s */ %d,\n};\n" /* array end with '}' */
             ,type_nr[type_sorting[i]],ObjectNames[type_sorting[i]],hydraulic_type[type_sorting[i]]);
 else
   fprintf(file_destination, "  /* type%2d: %20s */ %d,\n"
             ,type_nr[type_sorting[i]],ObjectNames[type_sorting[i]],hydraulic_type[type_sorting[i]]);
 myTypeNumber=type_nr[type_sorting[i]]+1;
 }


fclose(file_destination); 
return(1);
} /* create_unit_order_init   */



/*----------------------------------------------------------------------------*/
int type_sorting_routine(int NumberOfObjects,
                         char ObjectNames[MAX_OBJECTS][NAME_LENGHT],
                         int object_type[MAX_OBJECTS],
                         char function_call[MAX_OBJECTS][1000],
                         int type_nr[MAX_OBJECTS],
                         int priority[MAX_OBJECTS],
                         int hydraulic_type[MAX_OBJECTS],
                         int type_sorting[MAX_TYPES]
)
{
int a=0; /* chriwi's debug */
int i,i1,i3;
int proof=0;
int ready=0;
int lower_type=0; /* used to sort type order for function calls */
int lower_type_pos=0;
#define MAX_TYPES 200
int type_selection[MAX_TYPES]; /* proof , if double types */


/* type sorting -------------------------------------------------------------*/
/* check double existance of type and sort types 1..n */
for (i=0;i<MAX_TYPES;i++) type_selection[i]=0; /* reset */
for (i=0;i<MAX_OBJECTS;i++) 
  if (type_nr[i]>0) 
     {
     type_selection[type_nr[i]]++;
     if (type_selection[type_nr[i]]>1) { /* check double existance */
       for (i1=0;i1<=i;i1++) 
         if (object_type[i]==type_object) 
           printf("ObjectNames[i_object:%d]:%30s.c \tTYPE:%d \n"
                  ,i1,ObjectNames[i1],type_nr[i1] );
       printf("create_type_call_routine: multiple type definition in "
        "ObjectNames[i_object:%d]:%s.c TYPE:%d \n"
        ,i,ObjectNames[i],type_nr[i] ); exit (-1);
       }
    } /* type found */

for (i=0;i<MAX_OBJECTS;i++) /* list all types with its selection number */
 if (type_selection[type_nr[i]]!=0) if (a) printf("########type_selection[%d]:%20s \t %.1d \n"
      ,i,ObjectNames[i],type_selection[ type_nr[i] ]);
/* sort types for the function calls */
i3=0; /* index in type_sorting array, wher the object number is stored */
for (i=0;i<NumberOfObjects;i++) type_selection[i]=0; /* reset selection */

for (i=0;i<NumberOfObjects;i++) { /* first loop */
  lower_type_pos=0;lower_type=MAX_TYPES;
  for (i1=0;i1<NumberOfObjects;i1++) /* 2nd loop */
    {
    if ( (object_type[i1]==type_object) && (type_selection[i1]==0) ) {
      if (a) printf(":::::::: %d: type_nr[%s.c]=%d \t select:%d \n"
            ,i1,ObjectNames[i1],type_nr[i1],type_selection[i1]);
      if (type_nr[i1]<lower_type) {lower_type=type_nr[i1]; lower_type_pos=i1;}
      }
    } /* end 2nd loop */
  type_selection[lower_type_pos]=1; /* lower_type_pos = [0..NumberOfObjects] */
  if (lower_type!=MAX_TYPES)
    {
    if (a) printf("###############lower_type:%d lower_type_pos:%d \n"
           ,lower_type,lower_type_pos);
    type_sorting[i3]=lower_type_pos;i3++;type_sorting[i3]=0;
    }
  } /* first loop */

for (i=0;i<i3;i++) {
  if (a) printf("type_sort: type_sorting[%d]:%d \ttype:%d \n" 
                ,i,type_sorting[i], type_nr[type_sorting[i]] );
  }
/*  end type sorting ---------------------------------------------------------*/
/*
i=0; do { if (a) printf("type_sort: type_sorting[%d]:%d \ttype:%d \n" 
                  ,i,type_sorting[i], type_nr[type_sorting[i]] );
   } while (  (type_sorting[i++]!=0) && (i>1) ) ;
*/
/* sorted type sequence in type_sorting[] with the i_object number */
return (i3); /* returns number of types in this list */
} /* type_sort_routine() */

