/* auto_router.c  */

#include <stdio.h>    
#include <stdlib.h>
#include <math.h> 
#include "global.h"


/*
int WriteXfigConnection now declared in global.h
010427 chriwi:pedantic flag added
*/
    
int GetOutsidePos(int *x_new,int *y_new,int x,int y,int i_connection,
                  int **compound_coordinates,int **connection,
                  int *direction,int ***input_box,int ***output_box);
int SortCompounds(int XY,int *sort,int **compound_coordinates);
int SearchNextBarrier(int *x_new,int *y_new,int x,int y,int direction,
                      int **compound_coordinates,int force_distance);
int GetVectorDirection(int *direction,int x,int y,int x_new,int y_new,
                       int **compound_coordinates,int *force_distance
                       ,int i_connection);


int auto_router(
                        char    ***line_word_array,     /**/
                        int     no_of_lines,            /**/
                        int     ***input_box,           /**/
                        int     ***output_box,          /**/
                        int     letter_max_line,
                        int     **compound_coordinates,
                        int     **connection,
                        int     **x_connection,
                        int     **y_connection )
{
/*
auto_router: connection start and end points are available from
connection[i][1] to connection[i][4] (x1,y1,x2,y2).
the corners of all compounds are also available in compound_coordinates
auto_roter tries to find the direct path from start point to
end point without crossing the compound areas.
first start and endpoints were searched in the compound array to
evaluate an correspondending outside position of these points.
(see GetOutsidePos which generates x_new,y_new from x,y )
alle edge points of the new connection lines were stored
in x_connection[i_connection][0..n],y_connection[i_connection][0..n]
were endpoints first are stored at the end of this array
[EDGE_MAX-1] and [EDGE_MAX-2] to prevent overwriting through
the following points.
the outer loop counts all connection thru i_connection; END symbol
is used to define end label.
an inside loop defines for the current connection all new edge points
thru the following strategy: 
starting from outside point of starting point GetVectorDirection()
defines a valid direction of the path (EndOutsidePoint).
SearchNextBarrier searches from all compounds a possible barrier,
so the direction has to change.
the inside loop exits with a ready_flag, which is given by the
valid Endpoint==EndOutsidePoint;

*/
int a=0; /* debug */
int i; /* index */
int i_connection=0; /* starts with 0 to connection[][1]=END */
int i_edge=0; /* index for edges */
int ready=0;
int x,y,x_new,y_new; /* line point */
int direction=0; /* init 0 , than XPOS,XNEG,YPOS,YNEG */
int direction_tmp=0; /* init 0 , than XPOS,XNEG,YPOS,YNEG */
int force_distance;
char line_string_field[400];
char *line_string;
int DotXfig_flag=1; /* write lines to .xfig */
int dx,dy,dx_new,dy_new; /* check valid distances */
int NoRouting=0;
int DirectRouting=0;


#define PEDANTIC 0 /* some more prints */

#define CHECK_CONNECTION 0 /* reads just one line from define section */
                           /* read out coords from edit-option in xfig */
                           /* and put them in X1,Y1,X2,Y2 . after executing
                              cnv.exe paste object to check routing 
                              Select connection by printing th connection
                              numbers and coords with a=1;
                           */

#if CHECK_CONNECTION
/* connection 21510 19800 21375 20430     */
connection[0][X1]=3011 ;
connection[0][Y1]=3258 ;
connection[0][X2]=8445 ;
connection[0][Y2]=11337;
connection[1][X1]=END;
#endif


if (a) printf("auto_router:\n");

line_string= (char*) line_string_field;



#define distance_object 100 /* line_out distance in pixels of xfig */

i=0;
if (a) {
 printf("---------------------auto_router:-----------\n");
 do {
  printf("%d: connection[%d][%d][%d][%d], line:%d offs:%d \n",i
        ,connection[i][1],connection[i][2],connection[i][3]
        ,connection[i][4],connection[i][5],connection[i][6]);
  i++;
 } while (connection[i][X1]!=END) ;
}

i_connection=0; 
do { /*scan connection[][] i_connection=0 to END */

 /* get outside positions of start and end of connection */
 x=connection[i_connection][X1];
 y=connection[i_connection][Y1];
 NoRouting=GetOutsidePos(&x_new,&y_new,x,y,i_connection,compound_coordinates
               ,connection,&direction,input_box,output_box);
 DirectRouting|=NoRouting; /* check Routing for this connection */
 x_connection[i_connection][0]=x;     /* orig point */
 y_connection[i_connection][0]=y;
 x_connection[i_connection][1]=x_new; /* 2nd point */
 y_connection[i_connection][1]=y_new;

 x=connection[i_connection][X2];
 y=connection[i_connection][Y2];
 NoRouting=GetOutsidePos(&x_new,&y_new,x,y,i_connection,compound_coordinates,
               connection,&direction_tmp,input_box,output_box);
 DirectRouting|=NoRouting;

 x_connection[i_connection][EDGE_MAX-1]=x; /* final point */
 y_connection[i_connection][EDGE_MAX-1]=y;
 x_connection[i_connection][EDGE_MAX-2]=x_new; /* store behind */
 y_connection[i_connection][EDGE_MAX-2]=y_new;

 if (a) printf("i_connection:%d GetOutsidePosStart:%d,%d "
               "GetOutsidePosEnd:%d,%d\n",i_connection,
    x_connection[i_connection][1],y_connection[i_connection][1],
    x_connection[i_connection][EDGE_MAX-2],
    y_connection[i_connection][EDGE_MAX-2]);
 
 /* check valid direction of OutSide points */
 dx    = x_connection[i_connection][0]
        -x_connection[i_connection][EDGE_MAX-1];
 dy    = y_connection[i_connection][0]
        -y_connection[i_connection][EDGE_MAX-1];
 dx_new= x_connection[i_connection][1]
        -x_connection[i_connection][EDGE_MAX-2];
 dy_new= y_connection[i_connection][1]
        -y_connection[i_connection][EDGE_MAX-2];

#if 0
 if (   (  ( ( dx<0) && (dx_new>0) ) ||( ( dx>0) && (dx_new<0) ) )
     || (  ( ( dy<0) && (dy_new>0) ) ||( ( dy>0) && (dy_new<0) ) )
    ) {
  printf("i_connection:%d dx:%d dy:%d dx_new:%d dy_new:%d exiting\n"
     ,i_connection,dx,dy,dx_new,dy_new);
  printf("auto_router: overlaping units , exiting \n");
 
  printf("\n2 1 0 3 4 7 0 0 -1 0.000 0 0 -1 0 0 2");
  printf("\n\t   0 0 %d %d\n",x_connection[i_connection][0]
              ,y_connection[i_connection][0]);
  /* exit (-1);  */
  }
#endif

 if (CHECK_CONNECTION) 
  printf("starting x0:%d,y0:%d-->x1:%d,y1:%d \n"
      ,x_connection[i_connection][1],y_connection[i_connection][1]
      ,x_connection[i_connection][EDGE_MAX-2],y_connection[i_connection][EDGE_MAX-2]);

 /* search free way thru compounds */
 i_edge=1; ready=0;
 force_distance=0; /* object in this way */
 do { /* search edges of current connection ----------------- */
  x=x_connection[i_connection][i_edge];
  y=y_connection[i_connection][i_edge];
  x_new=x_connection[i_connection][EDGE_MAX-2];
  y_new=y_connection[i_connection][EDGE_MAX-2];
  GetVectorDirection(&direction,x,y,x_new,y_new,compound_coordinates,
                     &force_distance,i_connection);
  if (DirectRouting) { /* go orthogonal to final point */
    switch (direction) {
    case XPOS: y_new=y; break;
    case XNEG: y_new=y; break;
    case YPOS: x_new=x; break;
    case YNEG: x_new=x; break;
    }
  }
  else SearchNextBarrier(&x_new,&y_new,x,y,direction,
                      compound_coordinates,force_distance);
  if (CHECK_CONNECTION) printf("auto_router:DirectRouting:%d\n",DirectRouting);

  if (  (x_new==x_connection[i_connection][EDGE_MAX-2])
      &&(y_new==y_connection[i_connection][EDGE_MAX-2]) ) ready=1;
  x_connection[i_connection][i_edge+1]=x_new;
  y_connection[i_connection][i_edge+1]=y_new;
  x_connection[i_connection][i_edge+2]=x_connection[i_connection][EDGE_MAX-1];
  y_connection[i_connection][i_edge+2]=y_connection[i_connection][EDGE_MAX-1];
  x_connection[i_connection][i_edge+3]=END;

  if (a) printf("edge:%d dir:%d force:%d ",i_edge,direction,force_distance);
  if (a) printf("x:%d y:%d x_new:%d y_new:%d finals:%d,%d\n"
        ,x,y,x_new,y_new,x_connection[i_connection][EDGE_MAX-2]
        ,y_connection[i_connection][EDGE_MAX-2]);

 } while ( (++i_edge<EDGE_MAX-2) && (!ready) );
if (i_edge==EDGE_MAX-2) { 
 if (PEDANTIC) {
  printf("auto_router:edge_max:%d !!! exiting !!!\n",i_edge);
  printf("x:%d y:%d x_new:%d y_new:%d finals:%d,%d\n"
        ,x,y,x_new,y_new,x_connection[i_connection][EDGE_MAX-2]
        ,y_connection[i_connection][EDGE_MAX-2]);
  printf("2 1 0 3 4 7 0 0 -1 0.000 0 0 -1 0 0 2");
  printf("\n\t   %d %d %d %d\n",connection[i_connection][X1],
  connection[i_connection][Y1],connection[i_connection][X2],
  connection[i_connection][Y2]);
 }
 /* complete connection with a simple connection */
  x_connection[i_connection][0]=connection[i_connection][X1];
  y_connection[i_connection][0]=connection[i_connection][Y1];
  x_connection[i_connection][1]=connection[i_connection][X1]; 
  y_connection[i_connection][1]=connection[i_connection][Y1]; 
  x_connection[i_connection][2]=connection[i_connection][X2];            
  y_connection[i_connection][2]=connection[i_connection][Y1]; 
  x_connection[i_connection][3]=connection[i_connection][X2];           
  y_connection[i_connection][3]=connection[i_connection][Y2];
  x_connection[i_connection][4]=connection[i_connection][X2];           
  y_connection[i_connection][4]=connection[i_connection][Y2];
  x_connection[i_connection][5]=END;
  i_edge=2;
 }

WriteXfigConnection(line_string,line_word_array,connection
                    ,i_connection, x_connection,y_connection,DotXfig_flag);


/* if (i_connection==1) exit (-1); */
 i_connection++; /* inc number */
DirectRouting=0; /* reset this */
} while (connection[i_connection][1]!=END);

if (CHECK_CONNECTION) {
 printf("auto_router:CHECK_CONNECTION==1 !! , abnormal exiting \n");exit(-1); }
return (1);
}

/*
Landscape
Center
Metric
A4
100.00
Single
0
1200 2
2 1 0 1 0 7 50 0 -1 0.000 0 0 -1 0 0 4
         4320 3825 6525 1260 8820 1260 10260 2880
*/
int GetOutsidePos(int *x_new,int *y_new,int x,int y,int i_connection,
                  int **compound_coordinates,int **connection,
                  int *direction,int ***input_box,int ***output_box
)
{
/* get nearest orthogonal outside pos of this line */
int a=0;
int i_compound=1;
int i,k; /* index */
int x1,y1,x2,y2; /* compound */
int dx,dy;
int d[5],d_tmp; /* distance */
int ready=0;
char dir_str[5][5]={"0","XPOS","XNEG","YPOS","YNEG"};
int NoRouting=0; /* prevent routing in case of points inside adjacent compound */
int i_unit=1,i_number=1;
#define X_DIR 5
#define Y_DIR 6

do { /* searching x,y in inboxes  */
 i_number=1;
 do {
  x1=input_box[i_unit][i_number][1];
  y1=input_box[i_unit][i_number][2];
  x2=input_box[i_unit][i_number][3];
  y2=input_box[i_unit][i_number][4];
  if (  (x>=x1) && (x<=x2) && (y>=y1) && (y<=y2) ) ready=1;
  if ( (x2<x1) || (y2<y1) ) { printf("x1:%d y1:%d x2:%d y2:%d\n",
                                     x1,y1,x2,y2);exit (-1) ; }
 } while ((!ready) && (input_box[i_unit][++i_number][1]!=END));
}while ((!ready) && (input_box[++i_unit][1][1]!=END));

if (!ready) {
i_unit=1;
do { /* searching x,y in  outboxes */
 i_number=1;
 do {
  x1=output_box[i_unit][i_number][1];
  y1=output_box[i_unit][i_number][2];
  x2=output_box[i_unit][i_number][3];
  y2=output_box[i_unit][i_number][4];
  if (  (x>=x1) && (x<=x2) && (y>=y1) && (y<=y2) ) ready=1;
 } while ((!ready) && (output_box[i_unit][++i_number][1]!=END));
}while ((!ready) && (output_box[++i_unit][1][1]!=END));
} /* now it should be found */

if (!ready) {
 printf("GetOutsidePos:x,y:%d %d not found in any boxes\n",x,y);
 exit (-1);
}
dx=abs(x2-x1);
dy=abs(y2-y1);
if (dx>dy) { /* looking for direct way out of box,go x-direction */
 *direction= X_DIR;
}
else { /* go y-direction, caused by vertical box */
 *direction= Y_DIR;
}
if (a) printf("direction:%s x,y:%d %d box:%d %d %d %d \n"
     ,dir_str[*direction],x,y,x1,y1,x2,y2);
if (a) printf("i_connection:%d found in i_unit:%d i_number:%d \n",
  i_connection,i_unit,i_number);
ready=0; /*reset */

do { /* scan compounds 1 .. END */
  x1=compound_coordinates[i_compound][1];
  y1=compound_coordinates[i_compound][2];
  x2=compound_coordinates[i_compound][3];
  y2=compound_coordinates[i_compound][4];
  if (0) printf("i_compound:%d [%d][%d][%d][%d]\n",
         i_compound,x1,y1,x2,y2);
 
  if (  (x>=x1) && (x<=x2) && (y>=y1) && (y<=y2) ) { /* inside ? */
     if (a) printf("i_con:%d [%d][%d] in i_compound:%d [%d][%d][%d][%d]\n",
            i_connection,x,y,i_compound,x1,y1,x2,y2);
     /* get postion and new outside position of this line */
     d[1]=abs(x-x1);d[2]=abs(x-x2);d[3]=abs(y-y1);d[4]=abs(y-y2);
     d_tmp=1e8;
     for (i=1;i<=4;i++) if (d[i]<d_tmp) { d_tmp=d[i]; k=i; }
     /* d_tmp is now smallest positiv distance to frame of compound */
     d_tmp+=distance_object; /* add minimum distance to object */
     /* outside_point is */
     if (a) printf("nearest distance is d[%d]:%d\n\n",k,d_tmp);
#if 0
     switch (k) 
      {
                    /* left from comp */
      case 1: *x_new=x1-distance_object; *y_new=y; *direction=XNEG; break; 
                    /* right from comp */
      case 2: *x_new=x2+distance_object; *y_new=y; *direction=XPOS; break;
                    /* upper */
      case 3: *y_new=y1-distance_object; *x_new=x; *direction=YNEG; break;
                    /* lower */
      case 4: *y_new=y2+distance_object; *x_new=x; *direction=YPOS; break; 
      }
#endif

     switch (*direction)
      {
      case X_DIR:
        if (a) printf("go X_DIR:d[1]:%d,%d\n",d[1],d[2]);
        if ( d[1]< d[2] ) { *x_new=x1-distance_object; *direction=XNEG; }
        else              { *x_new=x2+distance_object; *direction=XPOS; }
        *y_new=y;
        break;
      case Y_DIR:
        if (a) printf("go y_DIR:d[1]:%d,%d\n",d[3],d[4]);
        if ( d[3]< d[4] ) { *y_new=y1-distance_object; *direction=YNEG; }
        else              { *y_new=y2+distance_object; *direction=YPOS; }
        *x_new=x;
        break;
      default: printf("error mode\n"); exit (-1);

      }
      
     ready=1;
     if (a) printf("x_new,y_new:%d,%d\n",*x_new,*y_new);
  } /* inside */
   i_compound++;
} while ( ( compound_coordinates[i_compound][1]!=END ) && (!ready) );

/* check new position x_new,y_new to be outside of any other compound */
do { /* scan compounds 1 .. END */
  x1=compound_coordinates[i_compound][1];
  y1=compound_coordinates[i_compound][2];
  x2=compound_coordinates[i_compound][3];
  y2=compound_coordinates[i_compound][4];
  if (  (*x_new>=x1) && (*x_new<=x2) && (*y_new>=y1) && (*y_new<=y2) ){ 
      /*inside ?*/
   if (PEDANTIC) {
    printf("GetOutsidePos: OutSideCoords are inside of an compound x,y:%d,%d\n"
          ,*x_new,*y_new); 
     printf("\n2 1 0 3 4 7 0 0 -1 0.000 0 0 -1 0 0 2");
     printf("\n\t   0 0 %d %d\n",*x_new,*y_new);
   }
   *x_new=x;
   *y_new=y;
   NoRouting=1;  /* set non routing flag */        
   /* exit (-1);  */
  }
} while  ( compound_coordinates[++i_compound][1]!=END );

if (!ready) { printf("x,y:%d,%d not found in compounds\n",x,y); exit (-1); }
  
return (NoRouting); /* if ready == 0 ther is no binding of this connection */
}



int GetVectorDirection(int *direction,int x,int y,int x_new,int y_new,
                       int **compound_coordinates,int *force_distance,
                       int i_connection)
{
int a=0;
int dx=x_new-x;
int dy=y_new-y;
int x1,y1,x2,y2;
/* int direction_old=*direction; / * store */
int border=0 ; /* current point lies on rextricted compound border */
static int border_old=0; /* older boundary */
int i_compound=1;
int touch_compound=0;
int force_distance2=0;
char dir_str[5][5]={"0","XPOS","XNEG","YPOS","YNEG"};
/*#define XPOS 1 #define XNEG 2 #define YPOS 3 #define YNEG 4 */
/* this routine define the path orientation to the next point
   if direction was changing and no border is reached the
   orientation is defined by the largest dx,dy value
*/

/* check old value of direction to slect next vector direction */

*force_distance=0; /* reset that */

/* simply defining new direction over final coords */
if ( abs(dx) > abs(dy) ) { /* go x-direction */
 if (x_new>x) *direction=XPOS;
 else         *direction=XNEG;
} 
else { /* go y-direction */
 if (y_new>y) *direction=YPOS; /* goes down */
 else         *direction=YNEG;
}

/* check and prevent possible ping pong effects of routing */
if (  ( (border_old==XNEG) && (*direction==XPOS) )  /* don't not play ping pong */
    ||( (border_old==XPOS) && (*direction==XNEG) ) ) {
 if (CHECK_CONNECTION) printf("!!!!! border_old==XNEG && *direction==XPOS !\n");
 if (y_new>y) *direction=YPOS; /* goes down */
 else         *direction=YNEG;
}
if (  ( (border_old==YNEG) && (*direction==YPOS) )  /* don't not play ping pong */
    ||( (border_old==YPOS) && (*direction==YNEG) ) ) {
 if (CHECK_CONNECTION) printf("!!!!! border_old==YNEG && *direction==YPOS !\n");
 if (x_new>y) *direction=XPOS; /* goes down */
 else         *direction=XNEG;
}


/* check valid direction regarding to adjacent object */
/* looking for a border in this direction  */
do { /* search in sort_entries for next barriere */
  x1=compound_coordinates[i_compound][X1];
  y1=compound_coordinates[i_compound][Y1];
  x2=compound_coordinates[i_compound][X2];
  y2=compound_coordinates[i_compound][Y2];

  if ( (*direction==XPOS) && (x==x1-distance_object) && (y>=y1) && (y<=y2) ) {
    border=XPOS; /*no gothru*/
    touch_compound=i_compound; /* store this */
    }
  if ( (*direction==XNEG) && (x==x2+distance_object) && (y>=y1) && (y<=y2) ) {
    border=XNEG; /*no gothru*/
    touch_compound=i_compound; /* store this */
    }
  if ( (*direction==YPOS) && (y==y1-distance_object) && (x>=x1) && (x<=x2) ) {
    border=YPOS; /*no gothru*/
    touch_compound=i_compound; /* store this */
    }
  if ( (*direction==YNEG) && (y==y2+distance_object) && (x>=x1) && (x<=x2) ) {
    border=YNEG; /*no gothru*/
    touch_compound=i_compound; /* store this */
    }
} while (  (compound_coordinates[i_compound++][1]!=END) && (border==0) ) ;
if (CHECK_CONNECTION) 
  printf("GetVectorDirection:x:%d,y:%d-->x_new:%d,y_new:%d Direction:%s\n"
        ,x,y,x_new,y_new,dir_str[*direction]);
if (CHECK_CONNECTION)
  printf("GetVectorDirection:x1-dist:%d y1:%d y:%d \n",
    compound_coordinates[6][X1]-distance_object,compound_coordinates[6][Y1],
     compound_coordinates[6][Y2]);
if ( (CHECK_CONNECTION)&&(border>0) )
  printf("GetVectorDirection: touching compound:%d, " ,touch_compound);


if (  (border>0)  /*&& (border_old==0)*/ ) { /* restricted direction */
 if ( (*direction==XPOS) || (*direction==XNEG) ) {   /* change path */
   if (y_new>=y) { /* force y-positive direction,if (y_new==y) check distance */
     *direction=YPOS; 
     if (touch_compound!=0) 
       *force_distance=compound_coordinates[touch_compound][Y2]
                       -y+distance_object;
     if (CHECK_CONNECTION) printf("Force YPOS: dist:%d\n",*force_distance);
     if (y_new==y) { /* if(y_new==y)check distance an go short way */
       force_distance2=y-compound_coordinates[touch_compound][Y1]
                                   +distance_object;
       if (force_distance2< *force_distance) { /* change Dir */
         *direction=YNEG;
         if (touch_compound!=0) *force_distance=force_distance2;
         if (CHECK_CONNECTION) printf("Force YNEG: dist2<dist1:%d b1:%d b2:%d\n"
                                       ,*force_distance,border,border_old);
       } /* force_distance2<force_distance: go YNEG */
     } /* (x_new==x) */
   }
   else {
     *direction=YNEG;
     if (touch_compound!=0) 
       *force_distance=y-compound_coordinates[touch_compound][Y1]
                       +distance_object;
     if (CHECK_CONNECTION) printf("Force YNEG: dist:%d b1:%d b2:%d\n"
            ,*force_distance,border,border_old);
   }
 }
 else { /* old direction was YNEG of YPOS */
   if (x_new>=x) { /* force x-positive direction, if(x_new==x)check distance*/
     *direction=XPOS;
     if (touch_compound!=0) 
       *force_distance=compound_coordinates[touch_compound][X2]
                       -x+distance_object;
     if (CHECK_CONNECTION) printf("Force XPOS: dist:%d\n",*force_distance);
     if (x_new==x) { /* if(x_new==x)check distance an go short way */
       force_distance2=x-compound_coordinates[touch_compound][X1]
                                   +distance_object;
       if (force_distance2< *force_distance) { /* change Dir */
         *direction=XNEG;
         if (touch_compound!=0) *force_distance=force_distance2;
         if (CHECK_CONNECTION) printf("dist2<dist1 !!Force XNEG: dist:%d\n",
                                       *force_distance);
       } /* force_distance2<force_distance: go XNEG */
     } /* (x_new==x) */
   } /* (x_new>=x) */
   else { 
     *direction=XNEG;
     if (touch_compound!=0) 
       *force_distance=x-compound_coordinates[touch_compound][X1]
                       +distance_object;
     if (CHECK_CONNECTION) printf("Force XNEG: dist:%d\n",*force_distance);
   }
 }
} /* there was an border, force different way */
border_old=*direction; /* touch_compound; / * store border acktion */
if (*force_distance<0) {
 printf("*force_distance:%d\n",*force_distance); exit (-1);
}

if (a) printf("direction:%d XPOS:1,XNEG:2,YPOS:3,YNEG:4 force_distance:%d\n"
      ,*direction,*force_distance);
return (1);
}


int SearchNextBarrier(int *x_new,int *y_new,int x,int y,int direction,
                      int **compound_coordinates,int force_distance)
{
int ready=0;
int x1,y1,x2,y2; /* tmp-compound-coordinates */
int i_compound=1;
int i=0;
int sort[UNIT_MAX]; /* increasing order */
/* search next edge point, x_new and y_new must be inited with 
   next point coords 
   SearchNextBarrier should be executed until x_new and y_new are
   equal to initial x_new,y_new values 
   if force_distance!=0 next coord is incremented aith this distance
*/

switch (direction)
 {
 /*1:XPOS,2:XNEG,3:YPOS,4:YNEG*/
 case XPOS:
   SortCompounds(X1,sort,compound_coordinates);
   i=0;
   do { /* search in sort_entries for next barriere */
    i_compound=sort[i]; /* select size-sorted compounds */
    x1=compound_coordinates[i_compound][1];
    y1=compound_coordinates[i_compound][2];
    x2=compound_coordinates[i_compound][3];
    y2=compound_coordinates[i_compound][4];
    if ( (x1>x) && (x1<*x_new) && (y>y1) && (y<y2) ) ready=1;  /* no go thru */
   } while ( (sort[++i]!=END) && ( !ready ) ) ;

   if ( ready==0 ) *x_new=*x_new; /* no barriere */
   else if ( (x1-distance_object)>x) *x_new=x1-distance_object;
        else                         *x_new=x1;
   if (force_distance!=0) *x_new=x+force_distance;
   *y_new=y;  /* no shift */
  break;
 case XNEG:
   SortCompounds(X2,sort,compound_coordinates);
   i=0;
   do { /* search in sort_entries for next barriere */
    i_compound=sort[i]; /* select size-sorted compounds */
    x1=compound_coordinates[i_compound][1];
    y1=compound_coordinates[i_compound][2];
    x2=compound_coordinates[i_compound][3];
    y2=compound_coordinates[i_compound][4];
if (0) printf("x:%d x2:%d x_new:%d\n",x,x2,*x_new);
    if ( (x2<x) && (x2>*x_new) && (y>y1) && (y<y2) ) ready=1;  /* no go thru */
   } while ( (sort[++i]!=END) && ( !ready ) ) ;

   if ( ready==0 ) *x_new=*x_new; /* no barriere */
   else if ( (x2+distance_object)<x) *x_new=x2+distance_object;
        else                         *x_new=x2;
   if (force_distance!=0) *x_new=x-force_distance;
   *y_new=y;  /* no shift */
  break;
 case YPOS:
   SortCompounds(Y1,sort,compound_coordinates);
   i=0;
   do { /* search in sort_entries for next barriere */
    i_compound=sort[i]; /* select size-sorted compounds */
    x1=compound_coordinates[i_compound][1];
    y1=compound_coordinates[i_compound][2];
    x2=compound_coordinates[i_compound][3];
    y2=compound_coordinates[i_compound][4];
    if ( (y1>y) && (y1<*y_new) && (x>x1) && (x<x2) ) ready=1;  /* no go thru */
   } while ( (sort[++i]!=END) && ( !ready ) ) ;

   if ( ready==0 ) *y_new=*y_new; /* no barriere */
   else if ( (y1-distance_object)>y) *y_new=y1-distance_object;
        else                         *y_new=y1;
   *x_new=x;  /* no shift */
   if (force_distance!=0) *y_new=y+force_distance;
  break;
 case YNEG:
   SortCompounds(Y2,sort,compound_coordinates);
   i=0;
   do { /* search in sort_entries for next barriere */
    i_compound=sort[i]; /* select size-sorted compounds */
    x1=compound_coordinates[i_compound][1];
    y1=compound_coordinates[i_compound][2];
    x2=compound_coordinates[i_compound][3];
    y2=compound_coordinates[i_compound][4];
    if ( (y2<y) && (y2>*y_new) && (x>x1) && (x<x2) ) ready=1;  /* no go thru */
   } while ( (sort[++i]!=END) && ( !ready ) ) ;

   if ( ready==0 ) *y_new=*y_new; /* no barriere */
   else if ( (y2+distance_object)<y) *y_new=y2+distance_object;
        else                         *y_new=y2;
   if (force_distance!=0) *y_new=y-force_distance;
   *x_new=x;  /* no shift */
  break;
 default: printf("SearchNextBarrier: error direction:%d\n",direction);
            exit (-1);
 }

return (1);
}

int SortCompounds(int XY,int *sort,int **compound_coordinates)
{
int a=0;
int select[UNIT_MAX]; /* mark registred compounds */
int i_compound=1;
int i,i1,i_sort=0,i_max;
int max_compounds=1;
int min_tmp=1e8; /* minimum values */
int reverse_order=0;

if ( (XY==X2) || (XY==Y2) ) reverse_order=1;

/* get max_compounds */
do { /* scan compounds 1 .. END */
  i_compound++;
} while ( compound_coordinates[i_compound][1]!=END );
max_compounds=i_compound-1;
for (i=1;i<=max_compounds;i++) select[i]=0; /* init */

for (i1=1;i1<=max_compounds;i1++) { /* run n times thru min-get */
  min_tmp=1e8; /* minimum values init maximum */
  /* search minimum coordinate */
  for (i=1;i<=max_compounds;i++) {
   if ( (min_tmp>=compound_coordinates[i][XY]) && (select[i]==0) )
    min_tmp=compound_coordinates[i][XY];
  }
  /* search position of actual min_tmp */
  for (i=1;i<=max_compounds;i++) {
   if (min_tmp==compound_coordinates[i][XY]) {
     select[i]=1;
     sort[i_sort++]=i; /* store this one and select it */
     sort[i_sort]=END;
     }
  }
} /* n times ready */
if (a) {
 printf("SortCompounds: XY:%d\n",XY);
 for (i=1;i<=max_compounds;i++)
  printf("sort[%d]:%d=%d select:%d\n",i-1,sort[i-1]
        ,compound_coordinates[ sort[i-1] ] [XY],
        select[i] );
 }
if (reverse_order) { /* for XNEG and YNEG its reverse order ! */
 i_sort=0;i_max=0;
 do {
   i_max++;
   select[i_sort]=sort[i_sort]; /* store it */
 } while (sort[i_sort++]!=END);
 i_sort=0;
 do {
   sort[i_max-i_sort-2]= select[i_sort];
 } while (select[i_sort++]!=END);
i_sort=0; 
if (a) do { printf("r%d:%d\n",i_sort,sort[i_sort]);} 
       while (sort[i_sort++]!=END);
} /* end reverse_order */

return (1);
}


int WriteXfigConnection(char *line_string, char ***line_word_array,
                        int **connection,int i_connection,
                        int **x_connection,int **y_connection,int DotXfig_flag)

{
/* writes new line with n edges to .xfig and to line_string[] */
int a=0;
static int init=1;
static int i_edge=0; /* count edges */
FILE *dot_xfig;
int i=0,i1=0;
int points_max=0;
int i_columns;
char string[400],string1[400],string2[400];
char *line_string_pointer;

line_string[0]='\0'; /* string end init */
line_string_pointer=line_string; /* point to first char*/
for (i=0;i<400;i++) string[i]='\0';

if (init) {
 
 if ((dot_xfig=fopen(".xfig","w"))==NULL)
  { printf("auto_router: write-error .xfig \n");exit(-1); }
 sprintf(string,"#FIG 3.2\nLandscape\nCenter\nMetric\nA4    \n100.00\n"
                "Single\n0\n1200 2\n");
 if (DotXfig_flag) fprintf(dot_xfig,"%s" ,string);
 i=0; do { *line_string_pointer++=string[i]; } while (string[++i]!='\0');
 init=0;
}
else { /* second time append it */
 if ((dot_xfig=fopen(".xfig","a"))==NULL)
 { printf("auto_router: write-error .xfig \n");exit(-1); }
}
 

/* fprintf(dot_xfig,"2 1 0 1 4 7 50 0 -1 0.000 0 0 -1 0 0 2\n"); */
i1=0;
do {  
   sprintf(string,"%s"
          ,line_word_array[ connection[i_connection][I_LINE] ] [i1]);
   if (DotXfig_flag) fprintf(dot_xfig,"%s" ,string);
   i=0; do { *line_string_pointer++=string[i]; } while (string[++i]!='\0');
  if (line_word_array[ connection[i_connection][I_LINE] ] [i1+2][0]!='\0')
    {
    sprintf(string," ");
    if (DotXfig_flag) fprintf(dot_xfig,"%s" ,string);
    i=0; do { *line_string_pointer++=string[i]; } while (string[++i]!='\0');
    }
  /* else fprintf(dot_xfig," 2\n"); / * 2 points only */  
  i1++;
} while (line_word_array[ connection[i_connection][I_LINE] ] [i1+1] [0]!='\0'); 

i1=0;
do i1++; while (x_connection[i_connection][i1+1]!=END); 
points_max=i1; /* 0 .. points_max */
sprintf(string," %d",points_max+1); /* n points */
if (DotXfig_flag) fprintf(dot_xfig,"%s" ,string);
i=0; do { *line_string_pointer++=string[i]; } while (string[++i]!='\0');

/* if (DotXfig_flag) fprintf(dot_xfig," %d",points_max+1); / * n points */


i1=0;i_columns=0;
do { 
 sprintf(string1,"\n\t  ");
 sprintf(string2," %d %d",x_connection[i_connection][i1]
                         ,y_connection[i_connection][i1]);
 if (i_columns==0) sprintf(string,"%s%s",string1,string2);
 else              sprintf(string,"%s",string2);

 if (DotXfig_flag) fprintf(dot_xfig,"%s" ,string);
 i=0; do { *line_string_pointer++=string[i]; } while (string[++i]!='\0');
 i_columns++;
 if (i_columns==6) i_columns=0; /* max 6 x-y-pairs per line */
} while (x_connection[i_connection][++i1]!=END);
sprintf(string,"\n");
if (DotXfig_flag) fprintf(dot_xfig,"%s" ,string);
i=0; do { *line_string_pointer++=string[i]; } while (string[++i]!='\0');
*line_string_pointer='\0';



fclose(dot_xfig);
if (a) printf("line_str:%s len:%d\n",&line_string[0],strlen(line_string));
/*    exit (-1); / * !!!!!!!!!!!!!1 */

i_edge=0;

return (1);
}
