#include <stdio.h>    
#include <stdlib.h>
#include <string.h> 
#include <math.h>    
#include "global.h"

/*
000610 int par_max,int deriv_max included
001109 export function for out_labels INFO.OUT_COMMENT
001114 exit on out_no > OUT_MAX or out_comment==NULL
001123 remove file sim_new.dek on error
*/

/*----------------------------write_dek-----------------------*/
int write_dek(char ***line_word_array,int unit_max_xfig,
              double **par_xfig,char ***par_comment,
              double **inp_init_xfig,char ***inp_unit_xfig,
                     char ***inp_comment,
              double **deriv_xfig,char ***deriv_comment,
              double **out_xfig,char ***out_unit_xfig,
                     char ***out_comment,
              int *type_xfig,int *unit_xfig,
              char **info_line,
              int **input_unit_xfig,int **input_out_nr_xfig,
              int par_max,int deriv_max,int input_max)
{
const int a=0;
FILE *new_dek;
int i_unit,i,i1,no_par=0,no_inp=0,no_deriv=0,i2;
int check=-1;

if ((new_dek=fopen("sim_new.dek","w"))==NULL)
   { printf(" write-error sim.dek\n");exit(-1); }

fprintf(new_dek,
        "*\n*--- fig2dek convert by Christof Wittwer/FhG-ISE\n");

if (a) printf("\ndek_write following units: unit_max_xfig:%d \n"
 ,unit_max_xfig);
for (i_unit=1;i_unit<=unit_max_xfig;i_unit++)
  {
  if (a) { printf("%d,",i_unit); fflush(stdout); }
  /*-----------------------------UNIT 2   TYPE 65 info --*/
  fprintf(new_dek,"*\nUNIT %d  TYPE %d --------- "
         ,unit_xfig[i_unit]
         ,type_xfig[i_unit]);

  i=0; /* go through letters */
  while ( info_line[i_unit][i]!='\0')
   {fprintf(new_dek,"%c",info_line[i_unit][i]);i++; }
  fprintf(new_dek," ---------\n");

  /*------------------------------PARAMS 10--------------*/
  no_par=0;
  for (i=1;i<=par_max;i++)
    if(par_xfig[i_unit][i]!=-99.99) no_par=i;
  if (no_par>0) fprintf(new_dek,"PARAMS %d\n",no_par);
  for (i=1;i<=no_par;i++)
    {
    if (a) printf("write_pars:%d\n",i);
    fprintf(new_dek,"*  %d: ",i);
    i1=0; /* go through letters */
    while ( par_comment[i_unit][i][i1]!='\0')
     {fprintf(new_dek,"%c",par_comment[i_unit][i][i1]);i1++;}
    if (par_xfig[i_unit][i]==-99.99) /* if default */
     fprintf(new_dek,"\n"
                    "  0.0 \n");
    else
     fprintf(new_dek,"\n"
                    "  %g \n"
                    ,par_xfig[i_unit][i]);
    }

  /*------------------------------INPUTS 10--------------*/
  no_inp=0;
  for (i=1;i<=input_max;i++)
    if (inp_init_xfig[i_unit][i] != -99.99) no_inp=i;
  if (no_inp>0) fprintf(new_dek,"INPUTS %d\n",no_inp);
  for (i=1;i<=no_inp;i++)
    {
    if (a) printf("write_dek: i_unit:%d write_inps:%d no_inp:%d inp:%s:%d\n"
      ,i_unit,i,no_inp,inp_comment[i_unit][i],strlen(inp_comment[i_unit][i]));
    fprintf(new_dek,"*  %d: ",i);
    i1=0; /* go through letters */
    while ( inp_comment[i_unit][i][i1]!='\0')
     { 
     if (a) printf("i1:%d\n",i1);
     fprintf(new_dek,"%c",inp_comment[i_unit][i][i1]);i1++;}
    fprintf(new_dek,"\n"
                    "       %d,  %d "
                    ,input_unit_xfig  [i_unit][i]
                    ,input_out_nr_xfig[i_unit][i]);
    /* including out_labels to dek after input_connections */
    /* e.g.   1, 3  # WEATHER.Igh */
    if (input_unit_xfig  [i_unit][i]!=0) /* is there a connection? */
     {
     if (a) printf("out_labels\n");
     if (input_out_nr_xfig[i_unit][i]>OUT_MAX) /* may be out_max is out of range */
      {
      printf("write_dek:unit:%d out:%d > OUT_MAX:%d \n",i_unit,
           input_out_nr_xfig[i_unit][i],OUT_MAX); exit (-1);
      }
     /* try to print info_string of connected unit with dot out_label */
    fprintf(new_dek," # ");
    i2=0;while ( info_line[ input_unit_xfig  [i_unit][i] ][i2]!='\0')
      {fprintf(new_dek,"%c",info_line[ input_unit_xfig  [i_unit][i] ][i2] );i2++; }
    if (a) printf("get outlabel from:%s to %s i_unit:%d out:%d\n"
       ,info_line[ input_unit_xfig  [i_unit][i] ],info_line[i_unit]
       ,input_unit_xfig  [i_unit][i],input_out_nr_xfig[i_unit][i] );
    if (out_comment[input_unit_xfig  [i_unit][i]] /*  out_no is existant ? */
                   [input_out_nr_xfig[i_unit][i]]==NULL)
     { printf("write_dek: out_label not declared:unit:%d out_no:%d info:%s\n",
            input_unit_xfig  [i_unit][i],input_out_nr_xfig[i_unit][i],
            info_line[ input_unit_xfig  [i_unit][i] ] ); 
      fclose(new_dek);
      if (remove("sim_new.dek")==-1) { 
        printf(" write-error sim.dek\n");exit(-1);
        }
      else printf("write_dek: removing sim_new.dek\n");
      exit (-1);
     }
    fprintf(new_dek,"."); /* outlabel upto space */
    i2=0;while (  ( out_comment[input_unit_xfig  [i_unit][i]]
                               [input_out_nr_xfig[i_unit][i]][i2]!='\0')
                &&( out_comment[input_unit_xfig  [i_unit][i]]
                               [input_out_nr_xfig[i_unit][i]][i2]!=' ') 
                &&(i2<strlen( out_comment[input_unit_xfig  [i_unit][i]]
                                         [input_out_nr_xfig[i_unit][i]]) )
               )
     {
     fprintf(new_dek,"%c",out_comment[input_unit_xfig  [i_unit][i]]
                                      [input_out_nr_xfig[i_unit][i]][i2]); 
     i2++; 
     
     
         
     }
   
     }
    if (a) printf("out_labels ready \n");
    fprintf(new_dek,"\n");
    }

  /*------------------------------INPUT INITIAL VALUES-------*/
  if (no_inp>0)
   {
   fprintf(new_dek,"*   INPUT INITIAL VALUES\n");
   for (i=1;i<=no_inp;i++)
    {
    if (a) printf("write_inp_initials:%d i_unit:%d\n",i,i_unit);
    fprintf(new_dek,"*  %d: \n"
                    "  %g \n",i,inp_init_xfig[i_unit][i]);
    }
   fprintf(new_dek,"*");
   }

  /*------------------------------DERIVATIVES 8 ------*/
  no_deriv=0;
  for (i=1;i<=deriv_max;i++)
    if(deriv_xfig[i_unit][i] !=-99.99) no_deriv=i;
  if (no_deriv>0) fprintf(new_dek,"\nDERIVATIVES %d\n",no_deriv);
  for (i=1;i<=no_deriv;i++)
    {
    if (a) printf("write_derivs:%d\n",i);
    fprintf(new_dek,"*  %d: ",i);
    i1=0; /* go through letters */
    while ( deriv_comment[i_unit][i][i1]!='\0')
     {fprintf(new_dek,"%c",deriv_comment[i_unit][i][i1]);i1++;}
    if (deriv_xfig[i_unit][i]==-99.99) /* if default */
     fprintf(new_dek,"\n"
                    "   0.0\n");
    else
     fprintf(new_dek,"\n"
                    "   %g \n",deriv_xfig[i_unit][i]);
    }

  } /* next i_unit */
  if (a) printf("\n");

fclose(new_dek);
return (check);
}

