#2345678901234567890123456789012345678901234567890123456789012345678901234567890
#--------1---------2---------3---------4---------5---------6---------7---------8
set TYPEDEF "./src/init_type_def_str.c"
set SRCPATH "./src"
set wd [exec pwd]
set aktiv_input ""
set export "$wd/tmp/"
#xfig_bug auf 1 setzen falls objekte beim pasten nicht nochmal eingepackt werden
    set filetypes(1) {
	{"LaTex file"		{.tex}	}
	{"All files"		*}
    }
set xfig_bug 1
######PROC LOAD & SORT VALUES FROM .XFIG######################
proc Load_type {} {
   global Unit Type Info
   global ParName ParVal ParUnit ParComm
   global ParValEin ParUnitEin ParCommEin
   global InpName InpVal InpUnit InpComm
   global InpValEin InpUnitEin InpCommEin
   global OutName OutUnit OutComm
   global OutUnitEin OutCommEin
   global DerName DerVal DerUnit DerComm
   global DerValEin DerUnitEin DerCommEin
   global aktiv_input
set ParList ""
set OutList ""
set InpList ""
set DerList ""
set Unit ""
set Type ""

# .xfig einlesen
set DateiEin [open ".xfig" r]

while {![eof $DateiEin]} {
   gets $DateiEin Zeile

   if [regexp PAR $Zeile] {
      lappend ParList $Zeile
   } elseif [regexp OUT $Zeile] {
      lappend OutList $Zeile
   } elseif [regexp INP $Zeile] {
      lappend InpList $Zeile
   } elseif [regexp DERIV $Zeile] {
      lappend DerList $Zeile
   } elseif [regexp UNIT: $Zeile] {
      set Unit $Zeile
   } elseif [regexp TYPE: $Zeile] {
      set Type $Zeile
   } elseif [regexp INFO: $Zeile] {
      set Info $Zeile
   }
}

close $DateiEin

# Listen sortieren
set ParList [lsort -index 13 -dictionary $ParList] 
set OutList [lsort -index 13 -dictionary $OutList]
set InpList [lsort -index 13 -dictionary $InpList] 
set DerList [lsort -index 13 -dictionary $DerList] 

# Arrays fllen
set i 1
foreach Eintrag $ParList {
   set ParName($i) [lindex $Eintrag 13]
   set ParVal($i) [lindex $Eintrag 14]
   set ParUnit($i) [lindex $Eintrag 15]

   set Comm ""
   for {set j 16} {$j < [expr [llength $Eintrag]-1]} {incr j} {
      set Comm [concat $Comm "[lindex $Eintrag $j] "]
   }
   set ParComm($i) $Comm

   incr i
}

set i 1
foreach Eintrag $OutList {
   set OutName($i) [lindex $Eintrag 13]
   set OutUnit($i) [lindex $Eintrag 14]

   set Comm ""
   for {set j 16} {$j < [expr [llength $Eintrag]-1]} {incr j} {
      set Comm [concat $Comm "[lindex $Eintrag $j] "]
   }
   set OutComm($i) $Comm

   incr i
}

set i 1
foreach Eintrag $InpList {
   set InpName($i) [lindex $Eintrag 13]
   set InpVal($i) [lindex $Eintrag 14]
   set InpUnit($i) [lindex $Eintrag 15]

   set Comm ""
   for {set j 16} {$j < [expr [llength $Eintrag]-1]} {incr j} {
      set Comm [concat $Comm "[lindex $Eintrag $j] "]
   }
   set InpComm($i) $Comm

   incr i
}

set i 1
foreach Eintrag $DerList {
   set DerName($i) [lindex $Eintrag 13]
   set DerVal($i) [lindex $Eintrag 14]
   set DerUnit($i) [lindex $Eintrag 15]

   set Comm ""
   for {set j 16} {$j < [expr [llength $Eintrag]-1]} {incr j} {
      set Comm [concat $Comm "[lindex $Eintrag $j] "]
   }
   set DerComm($i) $Comm

   incr i
}

# Listen lschen
unset ParList
unset OutList
unset InpList
unset DerList

# Eigabevariablen
set ParValEin(0) ""
set ParUnitEin(0) ""
set ParCommEin(0) ""
set OutUnitEin(0) ""
set OutCommEin(0) ""
set InpValEin(0) ""
set InpUnitEin(0) ""
set InpCommEin(0) ""
set DerValEin(0) ""
set DerUnitEin(0) ""
set DerCommEin(0) ""
}

# Fenster erzeugen
proc Hauptmenu {} {
wm title . "info edit ColSim T. Knapp & K. Lustig" 
global Unit Type Info
global aktiv_input
wm resizable . 0 0

menu .menu -tearoff 0
bind . <Control-s> "SaveAndExit"
bind . <Control-q> "destroy ."
set m .menu.file
menu $m -tearoff 0
.menu add cascade -label file -menu $m -underline 0
$m add command -label "Sort & Update type from source" \
   -command {
   exec ./etc/xfig.ssc
    destroy .[string range [string tolower $aktiv_input] 0 2]
    destroy .ueber[string range [string tolower $aktiv_input] 0 2]
   $aktiv_input
   } -underline 12

$m add command -label "Get values from sim.dek" \
   -command {Get_val_from_sim [lindex $Info 14]} -underline 12
$m add command -label "Update all from source" \
   -command {Get_val_from_src [lindex $Type 14]} -underline 4
$m add command -label "Export entry to LaTex table" \
   -command {Export_to_latex} -underline 4
$m add command -label "Save and Exit" -command "SaveAndExit" -accelerator Ctrl-s -underline 0
$m add command -label "Exit without Save" -command "destroy ." -accelerator Ctrl-q  -underline 0

set m .menu.fields
menu $m -tearoff 0
.menu add cascade -label entries -menu $m -underline 1
$m add command -label Par -command  Parameter -underline 0
$m add command -label Input -command Input -underline 0
$m add command -label Output -command Output -underline 0
$m add command -label Deriv -command Deriv -underline 0

. configure -menu .menu

frame .ueber0 -bd 2
pack .ueber0 -side top -fill x
frame .ueber0.sep -relief ridge -bd 2 -height 2 -width 200
pack .ueber0.sep -side left -fill x -expand 1

frame .unit -bd 2
pack .unit -expand 1 -side top -fill x

label .unit.text -text Unit: -width 10 -anchor w
label .unit.ein -text [lindex $Unit 14] -width 20 -justify right -anchor e
pack .unit.text .unit.ein -side left

frame .type -bd 2
pack .type -expand 1 -side top -fill x

label .type.text -text Type: -width 10 -anchor w
label .type.ein -text [lindex $Type 14] -width 20 -justify right -anchor e
pack .type.text .type.ein -side left

frame .info -bd 2
pack .info -expand 1 -side top -fill x

label .info.text -text Info: -width 10 -anchor w
label .info.ein -text [lindex $Info 14] -width 20 -justify right -anchor e
pack .info.text .info.ein -side left
}
#--------------------------------------------------------------------------------
# Ereignisse verknpfen
# Default-Werte setzen

#-------------------------------------------------------------------------------
# Parameter ANFANG
proc Parameter {} {
   global ParName ParVal ParUnit ParComm
   global ParValEin ParUnitEin ParCommEin
   global aktiv_input
   set aktiv_input "Parameter"
   if [winfo exists .inp] {
      destroy .ueberinp .inp
   } elseif [winfo exists .out] {
      destroy .ueberout .out
   } elseif [winfo exists .der] {
      destroy .ueberder .der
   } elseif [winfo exists .par] return 

   frame .ueberpar -bd 2
   pack .ueberpar -side top -fill x
   label .ueberpar.text -text Par -width 6 -anchor w
   frame .ueberpar.sep -relief ridge -bd 2 -height 2
   pack .ueberpar.text -side left
   pack .ueberpar.sep -side left -fill x -expand 1

   frame .par -bd 2
   pack .par -expand 1 -side top -fill x

   frame .par.0 -bd 1
   pack .par.0 -side top -expand 1 -fill x

   label .par.0.text -width 10
   label .par.0.value -text value -width 10 -anchor w
   label .par.0.sep1 -width 3
   label .par.0.unit -text unit -width 8 -anchor w
   label .par.0.sep2 -width 3
   label .par.0.comment -text comment -width 20 -anchor w

   pack .par.0.text .par.0.value .par.0.sep1 .par.0.unit .par.0.sep2 \
      .par.0.comment -side left

   for {set i 1} {$i <= [array size ParVal]} {incr i} {
      frame .par.$i -bd 1
      pack .par.$i -side top -expand 1 -fill x

      label .par.$i.text -text "$ParName($i)" -width 10 -anchor w
      entry .par.$i.value -width 10 -relief sunken -bd 2 \
         -textvariable ParValEin($i) -justify right
      label .par.$i.sep1 -width 3
      entry .par.$i.unit -width 8 -relief sunken -bd 2 \
         -textvariable ParUnitEin($i) -justify right
      label .par.$i.sep2 -width 3
      entry .par.$i.comment -width 20 -relief sunken -bd 2 \
         -textvariable ParCommEin($i) -justify left
if { $i <  [array size ParVal]} {
	bind .par.$i.value <Return>  "focus .par.[expr $i+1].value" 		
	bind .par.$i.value <Down>  "focus .par.[expr $i+1].value" 		
}	
if {$i >1 } {bind .par.$i.value <Up>  "focus .par.[expr $i-1].value"} 			

      pack .par.$i.text .par.$i.value .par.$i.sep1 .par.$i.unit .par.$i.sep2 \
         .par.$i.comment -side left

      .par.$i.value delete 0 end
      .par.$i.value insert 0 $ParVal($i)
      .par.$i.unit delete 0 end
      .par.$i.unit insert 0 $ParUnit($i)
      .par.$i.comment delete 0 end
      .par.$i.comment insert 0 $ParComm($i)
   }
}
#-------------------------------------------------------------------------------
# Parameter ENDE

#-------------------------------------------------------------------------------
# Input ANFANG
proc Input {} {
   global InpName InpVal InpUnit InpComm
   global InpValEin InpUnitEin InpCommEin
   global aktiv_input
   set aktiv_input "Input"

   if [winfo exists .par] {
      destroy .ueberpar .par
   } elseif [winfo exists .out] {
      destroy .ueberout .out
   } elseif [winfo exists .der] {
      destroy .ueberder .der
   } elseif [winfo exists .inp] return

   frame .ueberinp -bd 2
   pack .ueberinp -side top -fill x
   label .ueberinp.text -text Inp -width 6 -anchor w
   frame .ueberinp.sep -relief ridge -bd 2 -height 2
   pack .ueberinp.text -side left
   pack .ueberinp.sep -side left -fill x -expand 1

   frame .inp -bd 2
   pack .inp -expand 1 -side top -fill x

   frame .inp.0 -bd 1
   pack .inp.0 -side top -expand 1 -fill x

   label .inp.0.text -width 10
   label .inp.0.value -text value -width 10 -anchor w
   label .inp.0.sep1 -width 3
   label .inp.0.unit -text unit -width 8 -anchor w
   label .inp.0.sep2 -width 3
   label .inp.0.comment -text comment -width 20 -anchor w

   pack .inp.0.text .inp.0.value .inp.0.sep1 .inp.0.unit .inp.0.sep2 \
      .inp.0.comment -side left

   for {set i 1} {$i <= [array size InpVal]} {incr i} {
      frame .inp.$i -bd 1
      pack .inp.$i -side top -expand 1 -fill x

      label .inp.$i.text -text "$InpName($i)" -width 10 -anchor w
      entry .inp.$i.value -width 10 -relief sunken -bd 2 \
         -textvariable InpValEin($i) -justify right
      label .inp.$i.sep1 -width 3
      entry .inp.$i.unit -width 8 -relief sunken -bd 2 \
         -textvariable InpUnitEin($i) -justify right
      label .inp.$i.sep2 -width 3
      entry .inp.$i.comment -width 20 -relief sunken -bd 2 \
         -textvariable InpCommEin($i) -justify left

      pack .inp.$i.text .inp.$i.value .inp.$i.sep1 .inp.$i.unit .inp.$i.sep2 \
         .inp.$i.comment -side left

      .inp.$i.value delete 0 end
      .inp.$i.value insert 0 $InpVal($i)
      .inp.$i.unit delete 0 end
      .inp.$i.unit insert 0 $InpUnit($i)
      .inp.$i.comment delete 0 end
      .inp.$i.comment insert 0 $InpComm($i)
   }
}
#-------------------------------------------------------------------------------
# Input ENDE

#-------------------------------------------------------------------------------
# Output ANFANG
proc Output {} {
   global OutName OutUnit OutComm
   global OutUnitEin OutCommEin
   global aktiv_input
   set aktiv_input "Output"

   if [winfo exists .par] {
      destroy .ueberpar .par
   } elseif [winfo exists .inp] {
      destroy .ueberinp .inp
   } elseif [winfo exists .der] {
      destroy .ueberder .der
   } elseif [winfo exists .out]  return

   frame .ueberout -bd 2
   pack .ueberout -side top -fill x
   label .ueberout.text -text Out -width 6 -anchor w
   frame .ueberout.sep -relief ridge -bd 2 -height 2
   pack .ueberout.text -side left
   pack .ueberout.sep -side left -fill x -expand 1

   frame .out -bd 2
   pack .out -expand 1 -side top -fill x

   frame .out.0 -bd 1
   pack .out.0 -side top -expand 1 -fill x

   label .out.0.text -width 10
   label .out.0.unit -text unit -width 8 -anchor w
   label .out.0.sep1 -width 3
   label .out.0.comment -text comment -width 20 -anchor w

   pack .out.0.text .out.0.unit .out.0.sep1 \
      .out.0.comment -side left
   
   for {set i 1} {$i <= [array size OutUnit]} {incr i} {
      frame .out.$i -bd 1
      pack .out.$i -side top -expand 1 -fill x

      label .out.$i.text -text "$OutName($i)" -width 10 -anchor w
      entry .out.$i.unit -width 8 -relief sunken -bd 2 \
         -textvariable OutUnitEin($i) -justify right
      label .out.$i.sep1 -width 3
      entry .out.$i.comment -width 20 -relief sunken -bd 2 \
         -textvariable OutCommEin($i) -justify left

      pack .out.$i.text .out.$i.unit .out.$i.sep1 \
         .out.$i.comment -side left

      .out.$i.unit delete 0 end
      .out.$i.unit insert 0 $OutUnit($i)
      .out.$i.comment delete 0 end
      .out.$i.comment insert 0 $OutComm($i)
   }
}
#-------------------------------------------------------------------------------
# Output ENDE

#-------------------------------------------------------------------------------
# Deriv ANFANG
proc Deriv {} {
   global DerName DerVal DerUnit DerComm
   global DerValEin DerUnitEin DerCommEin
   global aktiv_input
   set aktiv_input "Deriv"

   if [winfo exists .par] {
      destroy .ueberpar .par
   } elseif [winfo exists .out] {
      destroy .ueberout .out
   } elseif [winfo exist .inp] {
      destroy .ueberinp .inp
   } elseif [winfo exists .der] return

   frame .ueberder -bd 2
   pack .ueberder -side top -fill x
   label .ueberder.text -text Deriv -width 6 -anchor w
   frame .ueberder.sep -relief ridge -bd 2 -height 2
   pack .ueberder.text -side left
   pack .ueberder.sep -side left -fill x -expand 1

   frame .der -bd 2
   pack .der -expand 1 -side top -fill x

   frame .der.0 -bd 1
   pack .der.0 -side top -expand 1 -fill x

   label .der.0.text -width 10
   label .der.0.value -text value -width 10 -anchor w
   label .der.0.sep1 -width 3
   label .der.0.unit -text unit -width 8 -anchor w
   label .der.0.sep2 -width 3
   label .der.0.comment -text comment -width 20 -anchor w

   pack .der.0.text .der.0.value .der.0.sep1 .der.0.unit .der.0.sep2 \
      .der.0.comment -side left

   for {set i 1} {$i <= [array size DerVal]} {incr i} {
      frame .der.$i -bd 1
      pack .der.$i -side top -expand 1 -fill x

      label .der.$i.text -text "$DerName($i)" -width 10 -anchor w
      entry .der.$i.value -width 10 -relief sunken -bd 2 \
         -textvariable DerValEin($i) -justify right
      label .der.$i.sep1 -width 3
      entry .der.$i.unit -width 8 -relief sunken -bd 2 \
         -textvariable DerUnitEin($i) -justify right
      label .der.$i.sep2 -width 3
      entry .der.$i.comment -width 20 -relief sunken -bd 2 \
         -textvariable DerCommEin($i) -justify left

      pack .der.$i.text .der.$i.value .der.$i.sep1 .der.$i.unit .der.$i.sep2 \
         .der.$i.comment -side left

      .der.$i.value delete 0 end
      .der.$i.value insert 0 $DerVal($i)
      .der.$i.unit delete 0 end
      .der.$i.unit insert 0 $DerUnit($i)
      .der.$i.comment delete 0 end
      .der.$i.comment insert 0 $DerComm($i)
   }
}
#-------------------------------------------------------------------------------
# Deriv ENDE

#-------------------------------------------------------------------------------
# Save and Exit ANFANG
proc SaveAndExit {} {
   global ParName ParValEin ParUnitEin ParCommEin
   global ParVal ParUnit ParComm
   global InpName InpValEin InpUnitEin InpCommEin
   global InpVal InpUnit InpComm
   global OutName OutUnitEin OutCommEin
   global OutUnit OutComm
   global DerName DerValEin DerUnitEin DerCommEin
   global DerVal DerUnit DerComm
   global xfig_bug

   if {[array size InpValEin] < 2} {
      array set InpValEin [array get InpVal]
      array set InpUnitEin [array get InpUnit]
      array set InpCommEin [array get InpComm]
   }

   if {[array size OutUnitEin] < 2} {
      array set OutUnitEin [array get OutUnit]
      array set OutCommEin [array get OutComm]
   }

   if {[array size DerValEin] < 2} {
      array set DerValEin [array get DerVal]
      array set DerUnitEin [array get DerUnit]
      array set DerCommEin [array get DerComm]
   }

   # .xfig einlesen
   set DateiEin [open ".xfig" r]
#   set DateiAus [open ".xfig" w]
   set DateiAus [open ".xfig.aus" w]

   set ParZ 1
   set OutZ 1
   set InpZ 1
   set DerZ 1
   set lines 1
   while {![eof $DateiEin]} {
      gets $DateiEin Zeile
      if [regexp PAR $Zeile] {
         set Zeile [lreplace $Zeile 13 end]
         set Zeile [concat $Zeile $ParName($ParZ) $ParValEin($ParZ) \
            $ParUnitEin($ParZ) $ParCommEin($ParZ) {\001}]
         incr ParZ
      } elseif [regexp OUT $Zeile] {
         set Zeile [lreplace $Zeile 13 end]
         set Zeile [concat $Zeile $OutName($OutZ) $OutUnitEin($OutZ) \
            $OutCommEin($OutZ) {\001}]
         incr OutZ
      } elseif [regexp INP $Zeile] {
         set Zeile [lreplace $Zeile 13 end]
         set Zeile [concat $Zeile $InpName($InpZ) $InpValEin($InpZ) \
            $InpUnitEin($InpZ) $InpCommEin($InpZ) {\001}]
         incr InpZ
      } elseif [regexp DERIV $Zeile] {
         set Zeile [lreplace $Zeile 13 end]
         set Zeile [concat $Zeile $DerName($DerZ) $DerValEin($DerZ) \
            $DerUnitEin($DerZ) $DerCommEin($DerZ) {\001}]
         incr DerZ
      }
#xfig bug packt alle Objekte nochmal
	if {$xfig_bug==1} {
		set row($lines) $Zeile
   		incr lines}	

    	if {$xfig_bug==0} {  
   	   puts $DateiAus $Zeile}
   }

   close $DateiEin
   if {$xfig_bug==1} {
   for {set i 1} {$i<[expr $lines - 2]} {incr i} {
      if {$i!=10} {
       puts $DateiAus $row($i)} }
       		    }
   close $DateiAus

   destroy .
}

########PROC GET_VAL_FROM_SIM###############

proc Get_val_from_sim {type_name} {
   global ParVal ParUnit ParComm
   global ParValEin ParUnitEin ParCommEin
   global DerVal DerUnit DerComm
   global DerValEin DerUnitEin DerCommEin
#open sim.dek
puts "Info_edit warning: INPUTS are not updated"
   set SimEin [open "sim.dek" r]
gets $SimEin Zeile
    while {![eof $SimEin]} {
if { [lindex $Zeile 0] == "UNIT" && [lindex $Zeile 5] == $type_name } {
set unitnr [lindex $Zeile 1]
# reached right type in sim.dek
  while {[lrange $Zeile 0 1] != "UNIT [expr $unitnr +1]" } {
    gets $SimEin Zeile
    foreach section "Params Derivatives" {
      if {[lindex $Zeile 0] == [string toupper $section]} {
       set nr 1
       set entr  "[string range $section 0 2]" 
       set nr_max [lindex $Zeile 1]

       for {set i 1} {$i<=[expr $nr_max*2]} {incr i} {
         gets $SimEin Zeile
	 if {[lindex $Zeile 0] != "*"} {
         set [set entr]Val($nr) [lindex $Zeile 0]
         set [set entr]ValEin($nr) [lindex $Zeile 0]
	 incr nr
	} else {
	#comment, unit insert
         set [set entr]Unit($nr) [lindex $Zeile 2]
         set [set entr]UnitEin($nr) [lindex $Zeile 2]
         set [set entr]Comm($nr) [lrange $Zeile 3 end ]
         set [set entr]CommEin($nr) [lrange $Zeile 3 end]
	}	
      }
     }
   }
 } 
} else {
}  
 gets $SimEin Zeile
}
close $SimEin
}
########PROC GET_VAL_FROM_SRC###############

proc Get_val_from_src {type_nr} {
set pattern_list "Par Inp Out Deriv"
set BEGIN_FLAG 0
global TYPEDEF SRCPATH
   global ParVal ParUnit ParComm
   global ParValEin ParUnitEin ParCommEin
   global InpName InpVal InpUnit InpComm
   global InpValEin InpUnitEin InpCommEin
   global OutName OutUnit OutComm
   global OutUnitEin OutCommEin
   global DerName DerVal DerUnit DerComm
   global DerValEin DerUnitEin DerCommEin
#first get the source file
regsub , [exec grep "TYPE $type_nr " $TYPEDEF] "" grep_str
#make it relative to "SOURCE" (more save)
set src_index [expr [lsearch -exact $grep_str "SOURCE"]+1]
set src_file $SRCPATH/[lindex $grep_str $src_index]
puts $src_file
#now open the src file
set src_fp [open "$src_file" r]
    gets $src_fp Zeile
    while {[gets $src_fp] !="\{" } { };#ignoring header
    while {[lindex $Zeile 0] !="*/"} {
     gets $src_fp Zeile
    
     foreach section $pattern_list {
      if {[string match "[string toupper $section]*" [lindex $Zeile 0]] } {
	regexp {[0-9]+} [lindex $Zeile 0] nr
        set entr  "[string range $section 0 2]" 
	if {[regexp {^[\[]}  [lindex $Zeile 1]]} {
	set shift_flag 1 
	} else {
	set shift_flag 0
	}	
        set [set entr]Val($nr) [lindex $Zeile [expr 1 -$shift_flag]]
        set [set entr]ValEin($nr) [lindex $Zeile [expr 1 -$shift_flag]]
        set [set entr]Unit($nr) [lindex $Zeile [expr 2 -$shift_flag]]
        set [set entr]UnitEin($nr) [lindex $Zeile [expr 2 -$shift_flag]]
        set [set entr]Comm($nr) "[lrange $Zeile [expr 3 -$shift_flag] end]"
        set [set entr]CommEin($nr) "[lrange $Zeile [expr 3 -$shift_flag] end]"
#unused entries will be destroyed
#	if {[llength $Zeile] <=2} {
#	destroy .[string range [string tolower $entr] 0 2].$nr  }

     }
    }
   }
close $src_fp
}
########PROC EXPORT TO LATEX###############

proc Export_to_latex {} {
global export wd filetypes Info aktiv_input aktiv
set aktiv [string range $aktiv_input 0 2]
   global [set aktiv]Name [set aktiv]Val [set aktiv]Unit [set aktiv]Comm
   global [set aktiv]ValEin [set aktiv]UnitEin [set aktiv]CommEin [set aktiv]Export
for {set i 1} {$i<=[array size [set aktiv]Val]} {incr i} {
set [set aktiv]Export($i) 1
checkbutton .[string tolower [set aktiv]].$i.export -variable [set aktiv]Export($i) -justify center
pack .[string tolower [set aktiv]].$i.export -side left 
}
button .[string tolower [set aktiv]].0.export -text Export -command {
set initdir  $export
if {$initdir == "."} {set initdir $wd}
set file [tk_getSaveFile  -filetypes $filetypes(1) \
	    -initialdir $initdir\
	    -initialfile [lindex $Info 14]_[string tolower $aktiv].tex -defaultextension .tex]
  if {$file != ""} {
#export routine
#make header
      set texout [open "$file" w]
      puts $texout "\\begin\{tabular\}\{\|l\|r\|r\|\}  \\hline" 
      puts $texout "\{\\bf $aktiv_input  fr [split [lindex $Info 14] _] \} \& \{\\bf  Wert\} \& \{\\bf Einheit\} \\\\ \\hline" 

      for {set i 1} {$i<=[array size [set aktiv]Val]} {incr i} {
       if {[set [set aktiv]Export($i)]} {
	set comm ""
	#[set aktiv]se comment for LaTex toxic contents (&;_...)
#puts $[set aktiv]CommEin($i)
	regsub -all "&" [set [set aktiv]CommEin($i)] "\\\\\\\\&" liste;#first decontaminate the &
	regsub -all "=" $liste " = " liste
	regsub -all ":" $liste " : " liste
	regsub -all "," $liste " , " liste
	regsub -all ";" $liste " ; " liste
	regsub -all "<" $liste " \$<\$ " liste
	regsub -all ">" $liste " \$>\$ " liste
	regsub -all {\(}  $liste { \(} liste
	regsub -all {\)}  $liste {\) } liste

#puts $liste

	foreach element $liste {
	 #next disarm the _
	for {set under 0} {[regsub  "_" $element "UNDER\{" element]} {incr under} {
	 }
	 for {set j 1} {$j<=$under} {incr j} {
	  set element "$element \}"
	 }
	 if {$under!=0} {
	  regsub -all "UNDER" $element "_" element
	  set element "\$ $element \$"
	 }
	 set comm "$comm $element" 
        }
  	#Parse unit for LaTex       
         regsub -all "C" [set [set aktiv]UnitEin($i)] "\$^\\circ\$ C" unit
	 regsub -all "m2" $unit "m\$^2\$" unit
	 regsub -all "K2" $unit "K\$^2\$" unit
  	#[set aktiv]se value for LaTex       
         if [regsub -all "e" [set [set aktiv]ValEin($i)] "\$\\cdot 10^\{" value] {
	 set value "$value\}\$" 
	 } else {
	 set value [set [set aktiv]ValEin($i)]
	 }
	 
      puts $texout "$comm \& $value \& $unit \\\\ \\hline" 
      };#end of checkbutton
     }
     puts $texout "\\end\{tabular\}" 
     close $texout
  }
#end of Filselection or cancel
  for {set i 0} {$i<=[array size [set aktiv]Val]} {incr i} {
     destroy  .[string tolower  $aktiv].$i.export
  }


}
pack .[string tolower $aktiv].0.export -side left

}
#-------------------------------------------------------------------------------
# Save and Exit ENDE

#-------------------------------------------------------------------------------
# MsgNochNicht ANFANG
proc MsgNochNicht {w} {
   set button [tk_messageBox -icon info -type ok \
	-title "Noch nicht!!!" -parent $w\
	-message "Funktion noch nicht implementiert!"]
}
#-------------------------------------------------------------------------------
# MsgNochNicht ENDE
Load_type
Hauptmenu
Parameter
