#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "global.h"

/* 
001122 b0==-2 with iam table (1dim) declared 
010824 double *iam_diff added to inc_angl_mod2()
*/
/*-----------------------angle_modifier-iam---------------*/

double iam(int number,double teta);
int iam_table(int number,double *iam_diff_return,double teta,double *inc_angl );

double inc_angl_mod(int init_flag, double b0, double teta,double phi
                    ,double **iam)
{
printf("inc_angl_mod 1 used \n");
exit (-1);
return (1);
}


double inc_angl_mod2(int init_flag, double b0, double teta,double phi,
                     double *iam_diff)
{
  int a=0;   /*-------------debug flag -----------------*/
  double inc_angl=0;
  int dist=0;
  int pos=0;
  double diff=0.0;
  double step=0.0;
  double pi=3.141592;
  double rad=pi/180;
  static int local_init=1;
  static double **iam;  /* for iam-table */
  if ( local_init ) { local_init=0;
   iam=malloc_2double(NR_TETA_MAX,NR_PHI_MAX);
  }
if ( (*iam_diff==-1) || (b0<0) ) {
  iam_table((int) b0,iam_diff,teta,&inc_angl ); /* use table */
  if (0) printf("iam_diff:%.2f teta:%.1f inc_angl:%.2f\n"
   ,*iam_diff,teta,inc_angl);
if (b0<0) {return (inc_angl);};
}
printf("inc_angl_mod2 exit\n"); exit (-1);
  /* double tracked=1; */

  if (b0==-2)
   {
   /*                    0 10 20  30  40  50   60  70 80 90 */
   double iam_table[10]={1, 1, 1,0.9,0.8,0.9,0.85,0.6,0.3,0.0 };
   /*                    0  1  2   3   4   5    6   7   8   9 */
   int i_teta=(int) (teta/10.0+0.5);
   if (i_teta<0) i_teta=0;
   if (i_teta>9) i_teta=9;

   inc_angl=iam_table[i_teta];
   if (fabs(teta)>90) inc_angl=0;
   if (inc_angl<0)   inc_angl=0;
   if (inc_angl>1.2) inc_angl=1.2;
   if (a) printf("inc_angl: b0:%.4f teta:%.4f inc_angl:%.4f i:%d\n"
      ,b0,teta,inc_angl,i_teta);
   return (inc_angl);
   }
  if (b0!=-1) /*----------------------if bo -1 take iam-table -------------*/
   {

   b0=fabs(b0);
   if (fabs(teta)>90) inc_angl=0;
   else if (fabs(teta)>1) inc_angl=1-b0*(1/cos(teta*rad)-1);
        else              inc_angl=1; 

   if (inc_angl<0) inc_angl=0;
   if (inc_angl>1) inc_angl=1;
   if (a) printf("inc_angl:  b0:%.4f    teta:%.4f "
          "  inc_angl:%.4f \n",b0,teta,inc_angl);
   }
  else   /* ---------------------- take iam table from './iam/iam.dat' */
   {
   int cylinder_coordinates=1;

     /* static double iam[NR_TETA_MAX][NR_PHI_MAX]; buggy with to much elements */

   if (init_flag) 
     {
     FILE *iamfile;
     char line_array[200];
     char *line=line_array; 
     char *rest;
     double dummy;
     double fill=0;
     double teta_table[NR_TETA_MAX];
     int i_phi=0,i_teta=0,i_teta_max;
     
     if ((iamfile=fopen("./iam/iam_table.dat","r"))==NULL)
         { printf("no './iam/iam_table.dat' !! \n\n"); exit (-1); };
     fgets(line,200,iamfile); /* read headline and empty line .. skip */
     if (a) printf("last lin:%s\n",line);
     dummy=strtod(line,&rest);

     do {   /* scan all teta's in the headline */
       line= rest; 
       teta_table[i_teta]=strtod(line,&rest);
       if (a) printf("teta_table[%d]:%.2f \n",i_teta,teta_table[i_teta]);
       i_teta_max=i_teta;
       i_teta++;
       }
     while (teta_table[i_teta-1]<90);

     if (a) printf("headline ready\n");

     line=line_array;
     fgets(line,200,iamfile);  /* skip empty line */
 
     /* fill the iam arry with a dummy value */
     for   (i_teta=0;i_teta<=NR_TETA_MAX-1;i_teta++)
       for (i_phi =0;i_phi <=NR_PHI_MAX-1 ;i_phi++ ) iam[i_teta][i_phi]=XXX;

     while (fgets(line,200,iamfile)!=NULL)   /* read line */
       {
       phi=strtod(line,&rest);
       
       for (i_teta=0;i_teta<=i_teta_max;i_teta++)  /* scan all iams in this line */
        {
        line= rest;
        teta=teta_table[i_teta];
        iam[(int)   teta    ]
           [(int)  (phi+180)]=strtod(line,&rest);
        if (a) printf("iam_read: teta:%d phi+180:%d iam:%.2f \n"
                      , (int) teta,(int) (phi+180),iam[(int) teta]
                                                      [(int) (phi+180)] );
        }
        line=line_array;
       }
      fclose (iamfile);
      if ((iamfile=fopen("./iam/iam.dat","w"))==NULL)
         { printf("error open './iam/iam.dat' !! \n\n"); exit (-1); };
      
      fprintf(iamfile,"#teta phi iam \n#\n");


 /*Ermitteln der Abstaende der theta-werte, erwartet gleiche Abstaende zwischen
  allen theta und phi Werten in degree */
 
   dist=teta_table[1]-teta_table[0];
          
 /* lineares interpolieren zwischen den aus der Tabelle gelesenen theta-Werten fuer 
     in der Tabelle vorhandes phi,
     entspricht waagerechtem interpolieren in der Tabelle iam_file.dat */


     for  (i_phi=0;i_phi<=NR_PHI_MAX-1;i_phi+=dist){
           for  (i_teta=0;i_teta<=NR_TETA_MAX-2;i_teta++){ 
                pos=i_teta/dist;
                diff=iam[(pos+1)*dist][i_phi]-iam[pos*dist][i_phi];
                step=diff/dist;
                if  (iam[i_teta][i_phi]==XXX){
                   iam[i_teta][i_phi]=iam[pos*dist][i_phi]+step*(i_teta-pos*dist);
                }
                
          
            }
          
         }
/* lineares interpolieren zwischen den phi-Werten, jetzt fuer alle, auch die nur
   interpolierten theta-Werten,  
   entspricht senkrechtem Auffuellen der Tabelle iam_file.dat */

       for  (i_teta=0;i_teta<=NR_TETA_MAX-1;i_teta++){ 
             for  (i_phi=0;i_phi<=NR_PHI_MAX-2;i_phi++){
                pos=i_phi/dist;
                diff=iam[i_teta][(pos+1)*dist]-iam[i_teta][pos*dist];
                step=diff/dist;
                if  (iam[i_teta][i_phi]==XXX){
                   iam[i_teta][i_phi]=iam[i_teta][pos*dist]+step*(i_phi-pos*dist);
                }
             }
       }     

      /* now fill the rest of the iam-elements */
      for (i_teta=0;i_teta<=NR_TETA_MAX-1;i_teta+=5) {
        for (i_phi=0;i_phi<=NR_PHI_MAX-1;i_phi+=5) {
          if (iam[i_teta][i_phi]!=XXX) {   fill=iam[i_teta][i_phi]; }
          else                         {        iam[i_teta][i_phi]=fill; }
        if (cylinder_coordinates)
          fprintf(iamfile,"%.3f %.3f %.3f \n",sin((i_phi-180)*rad)*i_teta
                                             ,cos((i_phi-180)*rad)*i_teta
                                             ,iam[i_teta][i_phi]);
        else
          fprintf(iamfile,"%d %d %.3f\n",i_teta,i_phi-180,iam[i_teta][i_phi]);
        }
        fprintf(iamfile,"\n");
      }
      fclose (iamfile);
     printf("iam init done\n");
     } /* end of init iam-table--------------------------------------------------- */

    if (phi > 180) { printf("phi: %.2f set to  180\n",phi );phi = 180;};
    if (phi <-180) { printf("phi: %.2f set to -180\n",phi );phi =-180;};
    if (teta> 90 ) { /* printf("teta:%.2f set to   90\n",teta) */ ;teta=  90;};
    if (teta< 0  ) { printf("teta:%.2f set to    0\n",teta);teta=   0;};


      inc_angl=iam[(int) (teta)]
                  [(int) ( phi+180)] ;
      if ( (a) || (inc_angl>1.3) || (inc_angl<0) )
                printf("iam[teta:%d][phi:%d-180]:%.2f phi:%.2f teta:%.2f\n"
                ,(int) (teta),(int) ( phi+180),inc_angl,phi,teta);
     }

/* if (tracked ) inc_angl=1.00; */
return (inc_angl);
} /* inc_angl_mod2 */

int iam_table(int number,double *iam_diff_return,double teta,double *inc_angl ) 
 /*iam_table((int) b0,iam_diff,teta,&inc_angl )*/
{
static int init=1;
double a,b,h;
double pi=3.14159265;
double rad=pi/180;
double x1,x2,y1,y2;

double alpha,beta;
static double iam_diff=0;
double p_ges=0; /* get this */
double i_alpha,delta_alpha=1;
double R=1; /* radius */
double deltaM=0,M=0; /* mantel-guertel */
double error;

if (!init) {
 *inc_angl=iam(number,teta);
 *iam_diff_return=iam_diff;
}
else { 
init=0;

/* step with 1 degree steps along the shell */
for (i_alpha=0;i_alpha<=90-delta_alpha;i_alpha+=delta_alpha) {
 alpha=i_alpha;
 beta=i_alpha+delta_alpha;

 x1=cos(alpha*rad);y1=sin(alpha*rad);
 x2=cos(beta*rad); y2=sin(beta*rad);

 a=x1;
 b=x2;
 h=y2-y1;
 deltaM=2*pi*R*h;
 if (0) printf("alpha:%.2f x1:%.4f y1:%.4f x2:%.4f y2:%.4f deltaM:%.4f\n"
               ,alpha,x1,y1,x2,y2,deltaM);
 M+=deltaM;
 iam_diff+=deltaM*iam(number,i_alpha)*sin(alpha*rad); /* delta_A*iam */
 p_ges   +=deltaM*1.0                *sin(alpha*rad) ;
} /* i_alpha */
iam_diff/=(p_ges); /* mean value --> half sphere */
error=1-M/(0.5*4*pi*R*R);
printf("halb-kugelmantel:%.6f diskretes integral der guertel:%.6f error:%.4f%\n"
 ,0.5*4*pi*R*R,M,error*100);
printf("p_ges:%.4f iam_diff/A_hK:%.6f\n",p_ges,iam_diff/(0.5*4*pi*R*R) );
iam(number,1);
printf("test iam[87]:%.6f iam_diff:%.4f soll:%.4f\n",iam(number,86.5),iam_diff,
        0.844/0.923);
*iam_diff_return=iam_diff;
*inc_angl=iam(number,teta);
} /* init */
return(1);
}
double iam(int number,double teta) {
 int i;
 /* SMM */
 static double table[91];
 static int init=1;

 if (init) { /* get 1 degree table with linear approx */
  FILE *iam_file;
  char filename[]="iam.dat";
  int a=0;
  init=0;
  for (i=0;i<=90;i++) table[i]=0;
/*
  SMM a.gombert 
# "Winkel" 1:"SMM" 2:"SMS" 3:"SSM" 4:"SSS" 5:"UMM" 6:"UMS" 7:"USM" 8:"USS"
0 1.0000 1.0000 1.0000 1.0000 1.0000 1.0000 1.0000 1.0000 
15 1.0000 1.0000 1.0000 1.0000 1.0000 1.0000 1.0000 1.0000 
30 0.9952 0.9967 0.9853 0.9878 0.9938 0.9954 0.9858 0.9879 
45 0.9787 0.9777 0.9018 0.9010 0.9723 0.9724 0.8964 0.8961 
60 0.8960 0.8891 0.7081 0.7030 0.8729 0.8705 0.7061 0.7034 
70 0.7195 0.7109 0.5139 0.5083 0.6815 0.6807 0.5136 0.5107 
75 0.5659 0.5560 0.4173 0.4105 0.5268 0.5253 0.4117 0.4080 
90 0.0000 0.0000 0.0000 0.0000 0.0000 0.0000 0.0000 0.0000 

*/
switch (number) { /* b0=-1,-2 ... -12 */
 case -1: /* SMM */
  table[0 ]=1.0000;table[15]=1.0000;table[30]=0.9952;table[45]=0.9787;
  table[60]=0.8960;table[70]=0.7195;table[75]=0.5659;table[90]=0;
  break;
 case -2: /* SMS */
  table[0 ]=1.0000;table[15]=1.0000;table[30]=0.9967;table[45]=0.9777;
  table[60]=0.8891;table[70]=0.7109;table[75]=0.5560;table[90]=0;
  break;
 case -3: /* SSM */
  table[0 ]=1.0000;table[15]=1.0000;table[30]=0.9853;table[45]=0.9018;
  table[60]=0.7081;table[70]=0.5139;table[75]=0.4173;table[90]=0;
  break;
 case -4: /* SSS */
  table[0 ]=1.0000;table[15]=1.0000;table[30]=0.9878;table[45]=0.9010;
  table[60]=0.7030;table[70]=0.5083;table[75]=0.4105;table[90]=0;
  break;
 case -5: /* UMM */
  table[0 ]=1.0000;table[15]=1.0000;table[30]=0.9938;table[45]=0.9723;
  table[60]=0.8729;table[70]=0.6815;table[75]=0.5268;table[90]=0;
  break;
 case -6: /* UMS */
  table[0 ]=1.0000;table[15]=1.0000;table[30]=0.9954;table[45]=0.9724;
  table[60]=0.8705;table[70]=0.6807;table[75]=0.5253;table[90]=0;
  break;
 case -7: /* USM */
  table[0 ]=1.0000;table[15]=1.0000;table[30]=0.9858;table[45]=0.8964;
  table[60]=0.7061;table[70]=0.5136;table[75]=0.4117;table[90]=0;
  break;
 case -8: /* USS */
  table[0 ]=1.0000;table[15]=1.0000;table[30]=0.9879;table[45]=0.8961;
  table[60]=0.7034;table[70]=0.5107;table[75]=0.4080;table[90]=0;
  break;
 case -9: /* SPF AS599 */
  table[0 ]=1.0000;table[15]=1.0000;table[30]=0.9950;table[40]=0.9900;
  table[50]=0.9450;table[60]=0.8000;table[70]=0.4900;table[90]=0;
  break;
 case -10: /* SPF HT699 */
  table[0 ]=1.0000;table[15]=1.0000;table[30]=0.9950;table[40]=0.9900;
  table[50]=0.9500;table[60]=0.8800;table[70]=0.6500;table[90]=0;
  break;
 default: printf("iam number:%d error\n",number);
}

/*
#include "iam_table.dat" 
*/

  for (i=0;i<90;i++) { /* run thru table array and search for non-zero's */
   int i1=1,i2=0;
   while ( (table[i+i1]==0) && ( (i+i1)<90) ) {i1++;};
   for (i2=i+1;i2<=i+i1-1;i2++) { /* white linear approximation to table */
    table[i2]=table[i]+(i2-i)*(table[i+i1]-table[i])/(i1+1e-12);
    if (a) printf(" table[%d]:%f\n",i2,table[i2]);
   }
   i+=i1; /* skip to next entry e.g. table[15] */
   if (a) printf("i:%d i1:%d table[%d]:%f\n",i,i1,i,table[i]);
   i-=1; /* dec to prevent double inc from for next loop */
  } /* i++ */
  for (i=90;i>=0;i--) {  /* get normalized iam table (iam(0)=1 !! ) */
    if (table[0]==0) { printf("iam[0]==0!! exit\n");exit(-1); }
    else table[i]/=table[0];
  } /* i-- */


 /* white table to dat file */
 if ((iam_file=fopen(filename,"w"))==NULL)
        { printf("error file open '%s' !! \n\n",filename); exit (-1); };

 fprintf(iam_file,"#teta iam\n#\n");
 for (i=0;i<=90;i++) fprintf(iam_file,"%d %f\n",i,table[i]);
 fclose(iam_file);
 } /* init() */

if ( (teta<0) || (teta>90) ) {
 /* printf("iam: teta:%.2f error\n",teta);  */
 teta=90;
}
return ( table[(int) (teta+0.5)] );
} /* iam() */

