#include "global.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "rad_processor.h" /*werner*/

/*
000607 pointer lenght,latitude
001114 solartime() included with ellipse figure  
       if ( fabs(teta)   >= 80*rad ) Rb=0;
       if (Rb>25) Rb=25.0;
010329 mode IGT_MES in rad_proc2 created
010608 create rad_processor.h
010816 switch (mode) Ibh, bug fix timer_flag A,B,C 
010824 chriwi: include werner modes in rad_proc1 & 2
       rad_proc2 bug fix: Rd,Rr,Rb static arrays created
       iam_diff added to args rad_proc2, iam activated
010920 rad_proc2: double *timezone added
011002 stebus: Added 'double shadow' and 'double rho_shading' to the struct
       radiation in the global.orig.h .
011003 stebus: if mode_shading=1 reduce by shading element was calcatad also
       for the wall. buggy! now only for window or TWD.
ToDo Rb[UNIT_MAX],Rr[UNIT_MAX] arrays at init with no rewrite
*/

#define OlderStyle 0 /* update rad_proc limits christiane */


void horizontal_to_tilted(double theta_h_rad,double phi_h_rad,double orientation
                           , double beta_rad,double *theta,double *phi);
void solartime(double *L_st, double *L_loc, int *locmin, int *solmin, 
		double *tst);
int rad_processor(double tsim,int day_of_year,double Ib_hor, double Id_hor
                  ,double rho_g,double E_40,double slope,double orientation
                  ,double *out,double *length,double *latitude, double Rd_horizon
                  ,double Rr_horizon)
  {
  /* this procedure calculates incidence angle of sun on a surface
     and evaluates beam and diffuse radiation on a surface
  */

  int a=0; /*-----------------Analyze a=1 ----------------*/
  double pi=3.14159265;
  double rad=pi/180;
  /* double time=tsim/3600; */
  double hour_angle;
  double dekl; /*declination of sun */
  double teta_z; /* solar zenith  */
  double gamma_s=0; /* solar azimut */
  double omega_ew=0;
  double teta; /* inc angle on surface */
  double theta; /*  inc angle Peter */
  double phi;
  double Rb,Rr,Rd; /*factors for tilted radiations */
  double IbT,IrT,IdT,IT; /* beam,refl,diff,total rad on tilted surface */
  double C1=0,C2=0,C3=0;
  double gamma_s_str; 
  double length1=length[0];
  double latitude1; /* use rad convert */
  double  L_st, L_loc , tst; 
  int  locmin,solmin;

 /* static double rad_proc[15]-->*out */
  L_st=-15; /* timezone GMT-1 or MEZ ==> 15 east */
  L_loc=length1;
  locmin=(day_of_year-1)*1440+tsim/60.0;

  solartime(&L_st, &L_loc, &locmin, &solmin,&tst);
 
  
  slope*=rad;       /* slope of surface */
                    /* azimut of surface 0:south, west pos */
  orientation*=rad; /* orientation of surface in rad */
                                     /* south=0,west=pi/2 */
  /* -7.85=lenght Freiburg */
  /* GEOGR. BREITE: 50.05 GRAD   GEOGR. LAENGE:  8.58 GRAD */
  /* Shft       = -15-(-1*8.58) */
  hour_angle= rad*( tst - 12 ) *15; /* tst solartime decimal of day [h] */
  /* hour_angle= rad*(( time - 12 ) * 15 - 15 - length1 );  bug 6/97 const lenght */

  if (latitude[0]==0) latitude1=48*rad; /* default freiburg.de */
  else                latitude1=latitude[0]*rad;

  if (a) printf("rad_proc:length:%.1f latitude:%.1f \n",length1,latitude1/rad);
  /* Declination:angle between equator-surface and sun 21.jun max=23.45 */
  /* dekl=-23.5*cos( ( 2*pi/365 )*( day_of_year+10)); Goetzberger & Wittwer*/
  /* dekl = 23.45 *rad*sin( rad * 360 * (day_of_year +284) / 365); */
  dekl=23.45*rad*sin(rad*360* ((284+(double) (day_of_year)) / 365)); /* DUF S.13 */
  if (0)
  {
  printf("dekl: day_of_year:%d arg:%.1f dekl:%.1f \n"
         ,day_of_year,360* ((284+(double) (day_of_year)) / 365),dekl/rad);
  }

  /* dekl=23.45*rad*sin(rad*360*(day_of_year)/365);  Declination 284+day_of_year */
  /* angle of incidence teta S.13 DUF something mesteriouse happened /
  */
    teta=acos(  sin(dekl)*sin(latitude1)*cos(slope)
            - sin(dekl)*cos(latitude1)*sin(slope)*cos(orientation)
	    + cos(dekl)*cos(latitude1)*cos(slope)*cos(hour_angle)
	    + cos(dekl)*sin(latitude1)*sin(slope)*cos(orientation)*cos(hour_angle)
	    + cos(dekl)*sin(slope)*sin(orientation)*sin(hour_angle)
	    );
  
  
     /* Goetzberger & Wittwer S.34 
       teta=acos(
                (cos(slope)*sin(latitude)-cos(latitude)*cos(orientation)*sin(slope)
                ) *sin(dekl)
	      + (sin(latitude)*cos(orientation)*sin(slope)+cos(slope)*cos(latitude)
	        ) *cos(dekl)*cos(hour_angle)
	      + (sin(orientation)*sin(slope)*cos(dekl)*sin(hour_angle) )
	        );
     */		
       
  teta_z=acos ( cos(latitude1)*cos(dekl)*cos(hour_angle)+sin(latitude1)*sin(dekl) );

  /* Brown and Mitchell radiation on plane */
  omega_ew=acos( (tan(dekl)/(tan(latitude1))));
  if ( fabs(hour_angle)  <=omega_ew ) C1= 1;
  else                                C1=-1;
  if ( (latitude1-dekl)>=0 ) C2= 1;
  else                 C2=-1;
  if ( hour_angle>=0 ) C3= 1;
  else                 C3=-1;
  gamma_s_str=asin( cos(dekl)*sin(hour_angle)/sin(teta_z) ) ; 
  gamma_s=rad*( C1*C2*gamma_s_str/rad+C3*(0.5*(1-C1*C2))*180);
    /* 2nd method:
      gamma_s_str=atan(  sin(hour_angle)/(sin(dekl)*cos(hour_angle)-cos(latitude)*tan(dekl))); /
      teta=acos( cos(teta_z*cos(slope)+sin(teta_z)*sin(slope)*cos(gamma_s-orientation)));
    */ 
    
  if (a)
  {
     printf("teta=%.8f slope=%.1f teta_z=%.1f",teta/rad,slope/rad, teta_z/rad);
     printf(" gamma_s=%.1f orientation=%.1f \n",gamma_s/rad,orientation/rad);
  }
  
  /* Rb ratio of beam S.25 DUF beam rad on tilted surface, gets strange result for TRY!! */
  Rb=cos(teta)/cos(teta_z+1e-12);  /* !! DUF-discription,problems with valid range!!e.g.Rb>10000!! */
  if (OlderStyle) {
    if ( fabs(teta)   >= 90*rad ) Rb=0; /* sun behind aperture */
    if ( fabs(teta)   >= 80*rad ) Rb=0;
    if (Rb>25) Rb=25.0;
    /* if ( fabs(teta_z) >= 85*rad ) Rb=1; / * not 0 ! , modification 5/98 */
    /* if (Rb>25) Rb=25.0; / * chriwi !!!!!!!!  limit to sth , modification 5/98 */
    if (Rb<0)  Rb=0;
    /* check beam radiation Ibh=Ib_hor*Rb*/
    
    if (  (Ib_hor*Rb>800) && (teta_z/rad>70) ) /* sun less than 20 over horizon */
      { printf("Rb:%.1f IbT:%.1f && teta_zenith:%.1f>70: teta:%.1f...  fixed to 800 W/m2 \n"
               ,Ib_hor*Rb,Rb,teta_z/rad,teta/rad);
        Rb=800.0/Ib_hor;
        /* IbT=800; */  /* !!!!!!!!!! set limit of IbT */
      }
  } 
  else { /* NewerStyle */
      /* Correction necessary since both Ib_hor and cos(teta_z) are very small */
      /* This method seems plausible but yields much less radiation than Trnsys:*/
      /* Calculate extraterrestrial radiation times transmission factor as limit*/
      /* This method almost reproduces Trnsys results:*/

    /* if (cos(teta_z)!=0) Rb=cos(teta)/cos(teta_z); */
    if ((teta_z>=95.0*rad)||(teta >= 90*rad )) Rb=0;  
    else {
     if (teta_z > 87.0*rad) {
        Rb=cos(teta)/cos(87.0*rad); /* Keep Rb const.*/
        if (Ib_hor<=0) Rb=0;
     }
    }
  }  
  if (a) printf("teta=%.2f teta_z=%.2f Rb=%.2f gamma_s=%.2f ", teta/rad,teta_z/rad,Rb,gamma_s/rad);
  
  
  /* diffuse radiation: isotropic sky , DUFFI */
  /* Liu an Jordan Duf.S.94 
   IgT=Ibh*Rb+Idh*(0.5*(1+cos(beta)))+Igh*albed*( 0.5*(1-cos(beta)))
  */
  if (Rd_horizon==0) Rd=0.5*(1+cos(slope)); /* no external calculation (horizon.c) */
  else               Rd=Rd_horizon;

  if (fabs (Rd) > 2) printf ("rad_proc:Rd=%.2f\n", Rd); /*reflected rad */
  if (Rr_horizon==0) Rr=0.5*(1-cos(slope))*rho_g; /* albedo */
  else               Rr=Rr_horizon; /* external calculation */

  if (a) printf("Rd:%.4f Rd_horizon:%.4f Rr:%.4f Rr_horizon:%.4f \n"
            ,0.5*(1+cos(slope)),Rd_horizon,0.5*(1-cos(slope))*rho_g,Rr_horizon);

  if (fabs(Rr)>2) printf("rad_proc Rr<0:%.4f\n",Rr);

  IbT=Ib_hor*Rb; /* Ibeam correction */
  IdT=Id_hor*Rd; /* diffus */
  IrT=Rr*(Ib_hor+Id_hor);  /* reflective */

  IT=IdT+IrT+IbT; /* total radiation */

/* werner -> start use of E_40global */

  if (E_40!=0)
       {
   /* Parameter fuer den 30% Ansatz Diffusanteil bei 800W/m^2*/
         double a1=1.29321; 
         double a2=-0.001445;
   
   /* Parameter fuer den 20% Ansatz Diffusanteil bei 800W/m^2 * /
         double a1=1.25408;
         double a2=-0.0018201;
   */

         IdT=(a1*E_40*exp(a2*E_40));/* Ansatz mit 20 oder 30% Diffusanteil
                                        an sonnigen Tagen*/
         IbT=E_40-IdT;

         if (IdT<=0) { IdT=0;IbT=0; }
         if (IbT<=0) {       IbT=0; }
         IrT=Rr*(IbT+IdT);
         if (1) printf("mode E_40###IbT:%.4f  IdT%.4f IrT:%.4f   E_40:%.4f \n"
                       ,IbT,IdT,IrT,E_40);
         IT=IdT+IrT+IbT; /* total radiation */
        }
/* <- werner  end use of E_40 */

  /* phi */
  horizontal_to_tilted(teta_z,gamma_s,orientation,slope,&theta,&phi);

  out[0]=0;
  out[1]=teta_z/rad; /* solar zenith  */
  out[2]=gamma_s/rad; /* solar azimut */
  out[3]=teta/rad; /* inc angle on surface */
  out[4]=IbT; /* beam rad on tilted surface */
  out[5]=IrT; /* refl rad on tilted surface */
  out[6]=IdT; /* diff rad on tilted surface */
  out[7]=IT;   /* total radiation on tilted surface */
  out[8]=dekl/rad; /*declination of sun */
  out[9]=hour_angle/rad;
  out[10]=teta/rad; /* teta */
  out[11]=phi/rad;  
  out[12]=Rb; /*Ratio Ibh/IbT */
if (fabs((out[10]-out[3])>1)) printf("teta:%.1f theta:%.2f \n",out[10],out[3]);
  return (1);
}

/***************written by Peter Schossig/ISE *****************************/
void horizontal_to_tilted(double theta_h_rad,double phi_h_rad,double orientation
                           , double beta_rad,double *theta,double *phi)
         {
        int a=0;
        double  x_h,y_h,z_h,x_t,y_t,z_t;
        int     c;
        double pi=3.14159265;
        double rad=3.14159265/180.0;

        x_h = sin(theta_h_rad)*cos(-phi_h_rad);
        y_h = sin(theta_h_rad)*sin(-phi_h_rad);
        z_h = cos(theta_h_rad);
        x_t = x_h*cos(beta_rad)*cos(orientation)-y_h*sin(orientation)*cos(beta_rad)
             -z_h*sin(beta_rad);
        y_t = x_h*sin(orientation)+y_h*cos(orientation);
        z_t = x_h*sin(beta_rad)*cos(orientation)-y_h*sin(orientation)*sin(beta_rad)
             +z_h*cos(beta_rad);

        if (x_t>=0.0) c=0;
        else if(x_t<0.0 && y_t<0.0) c=1;
        else c=-1;

        *theta= atan(sqrt(x_t*x_t+y_t*y_t)/z_t);
        *phi  = atan(-y_t/x_t)+c*pi;
                                
        if (a) printf("phi:horizontal_to_tilted: theta_h:%.2f phi_h:%.2f orientation:%.2f"
         " beta:%.2f theta:%.2f phi:%.2f \n",theta_h_rad/rad,phi_h_rad/rad,orientation/rad,
         beta_rad/rad,*theta/rad,*phi/rad);
        }
/*      end of horizontal_to_tilted                                       */ 
/**************************************************************************/
/**************************************************************************/
/* solartime
   braucht Standardmeridian, Laengengrad, lokale Uhrzeit (Winterzeit) in Minuten ab 1.Januar
   und liefert solar time in Minuten ab 1.Januar und solar time in Stunden des 
   Tages
   double *L_st ist der Standartmeridian der lokalen Zeitzone in Grad West 
   double *L_loc ist der Lngengrad des Messstandortes in Grad West
   int *locmin ist die lokale Uhrzeit (Winterzeit) in Minuten ab 1.Januar
   int *solmin ist die 'solar time' am Messstandort in Minuten ab 1.Januar
   double *tst ist die 'solar time' am Messstandort in Stunden des Tages
*/
void solartime(double *L_st, double *L_loc, int *locmin, int *solmin, 
		double *tst){
				/* solartime in min nach Duffie/Beckman (p.11)*/
				/* Vorsicht: Winkel stehen im D./B. in Grad*/

	double E,B;
	double solarkorr;
	int n;
	
	n= 1+(int)((*locmin-1)/1440);  /* liefert den  aktuellen Tag des Jahres        */
	B=(n-1)*360/365;               /* Parameter fr die Zeitverschiebung durch die */
	                               /* Perturbation der Erdbahn                     */
	B=B*PI/180;                    /* Umrechnung Grad in rad                       */
	E=229.2*(0.000075+0.001868*cos(B)-0.032077*sin(B)-0.014615*cos(2*B)
			-0.04089*sin(2*B));    /* Zeitverschiebung durch die Perturbation  */
	solarkorr=4*(*L_st - *L_loc)+E;  /* Zeitverschiebung durch Abweichung vom  Standart-*/
	                                 /* meridian + Zeitverschiebung durch die Perturbation */
	*solmin = *locmin + solarkorr;   /*  solar time' am Messstandort in Minuten ab 1.Januar*/
	*tst=(*solmin-24*60*(int)(*locmin/60/24))/60.0;
	                       /*   'solar time' am Messstandort in Stunden des Tages*/
	}
/*      end of solartime						  */
/**************************************************************************/


/*
int rad_proc2(struct sim_struct *info,
              struct radiation_struct *radiation,
              double *Ibt,double *Idt,
              double *Igt,double *out,
              double Igh,double Idh,double Ibn,double Igt_mess,
              int mode,int init_flag,double tsim,double h,int day_of_year,
              int horizon_nr,double b0,double iam_diff,
              double slope,double orientation,double *timezone,
              double *lenght,double *latitude,
              double rho_g,int unit)
*/
int rad_proc2(struct sim_struct *info,
              struct interface_struct *interface,
              struct radiation_struct *radiation)
  {
  /* this procedure calculates incidence angle of sun on a surface
     and evaluates beam and diffuse radiation on a surface
     mode1:Igh & Idh are default inputs
     mode2:Igt_mess
     mode3:Igt_mess & Igh       
     mode4:Igh & Ibn
  */

  int a=0; /*-----------------Analyze a=1 ----------------*/
  static int local_init=1;
  double pi=PI;
  double rad=pi/180;
  double hour_angle;
  double gamma_s=0,gamma_s_rad=0; /* solar azimut */
  double gamma_s_str; 
  double theta_z,theta_z_rad=0; /* solar zenith  */
  double theta,theta_rad; /* inc angle on surface */
  double phi_rad;
 /* double Rb,Rr=0,Rd=0; / * factors for tilted radiations */
  static double Rb[UNIT_MAX],Rr[UNIT_MAX],Rd[UNIT_MAX]; /* store at init */
  static double Rr_horizon[UNIT_MAX],Rd_horizon[UNIT_MAX]; 
                                                     /* from horizon routine */
  double Ibh,IbT,IrT,IdT,IT; /* beam,refl,diff,total rad on tilted surface */
  double shadow=0; /* no shading */
  double inc_angl=1; /* fytor for incidence angle_mod */
  int timer_flag=1; /* 0: use this timer with TIMER_SET_FOR_SKY */
  static double timer=0;
  static double tsim_last=-10;
  static double L_st,L_loc,tst; 
  static int  locmin,solmin;
  static double dekl; /*declination of sun */
  static double sin_hour_angle;                 
  static double cos_hour_angle;                 
  static double A0,B0,C0,D0,E0; /* parameters */
  static double A,B,C,D,E,F,G; /* parameters */
  static double omega_ew;
  static double C1=0,C2=0,C3=0;
  
  int    init_flag=info->init_flag;
  double tsim=info->tsim;
  double h=info->h;
  int    day_of_year=info->day_of_year;
  int    horizon_nr=radiation->horizon_nr;
  double b0=radiation->b0;
  double iam_diff=radiation->iam_diff;
  double slope=radiation->slope;
  double orientation=radiation->orientation;
  double rho_g=radiation->rho_g;
  int    unit=info->unit;
  double Igh=radiation->Igh;
  double Idh=radiation->Idh;
  double Ibn=radiation->Ibn;

  /* calculated sizes 
  double Igt=0,Ibt=0,Idt=0; */

/*
struct sim_struct *info,
              struct radiation_struct *radiation,
              double *Ibt,double *Idt,
              double *Igt,double *out,
              double Igh,double Idh,double Ibn,double Igt_mess,
              int mode,int init_flag,double tsim,double h,int day_of_year,
              int horizon_nr,double b0,double iam_diff,
              double slope,double orientation,double *timezone,
              double *lenght,double *latitude,
              double rho_g,int unit)
*/

/*
if (mode==IGH_IBH) printf("Ibn:%.1f Igh:%.1f \n",Ibn,Igh);
*/
if (init_flag) { /* check mode */
 if (!( (radiation->mode==IGH_IDH) || (radiation->mode==IGT_MES) 
        || (radiation->mode==IGT_IGH)  
     || (radiation->mode==IGH_IBN) || (radiation->mode==IGH_MES) )) {
  printf("rad_proc2:exit on unknown mode:%d\n",radiation->mode); exit (-1);
 }  
  /* reset statics */
 Rb[unit]=Rr[unit]=Rd[unit]=Rr_horizon[unit]=Rd_horizon[unit]=0; 
}

/*___________________mode==IGT_MES__->_____________*/
if (radiation->mode==IGT_MES) { 
#if 1 
/* werner -> start use of Igt_mess */

/* Parameter fuer den 30% Ansatz Diffusanteil*/
   double a1=1.29321; 
   double a2=-0.001445;


/* Parameter fuer den 20% Ansatz Diffusanteil* /
   double a1=1.25408;
   double a2=-0.0018201;
*/

   IdT=(a1*radiation->Igt_mess*exp(a2*radiation->Igt_mess));
              /* Ansatz mit 20 oder 30% Diffusanteil
                                 an sonnigen Tagen*/
   IbT=radiation->Igt_mess-IdT;
   if (IdT<=0) { IdT=0;IbT=0; }
   if (IbT<=0) {       IbT=0; }
   IrT=Rr[unit]*(IbT+IdT);
   if (a) printf("mode E_40###IbT:%.4f  IdT%.4f IrT:%.4f   Igt_mess:%.4f \n"
                ,IbT,IdT,IrT,radiation->Igt_mess);
   IT=IdT+IrT+IbT; /* total radiation */
   radiation->Ibt=IbT;
   radiation->Idt=IdT+IrT; /* diffus + reflec. */
   radiation->Igt=IT;
/* <- werner  end use of Igt_mess */
#endif

#if 0 /* easy mode for 30% */
  if (Igt_mess>400) { 
    *Ibt=0.3*Igt_mess;
    *Idt=0.7*Igt_mess;
  }
  else  {
    *Ibt=0;
    *Idt=Igt_mess;
  }
  *Igt=*Ibt+*Idt;
#endif
return (1);
} /* end mode IGT_MES */


/*___________________mode==IGT_IGHT__->_____________*/
if (radiation->mode==IGT_IGH) { /* not different to mode IGT_MES */
/*werner->*/
/* Parameter fuer den 30% Ansatz Diffusanteil*/
   double a1=1.29321; 
   double a2=-0.001445;


/* Parameter fuer den 20% Ansatz Diffusanteil* /
   double a1=1.25408;
   double a2=-0.0018201;
*/

   IdT=(a1*radiation->Igt_mess*exp(a2*radiation->Igt_mess));
    /* Ansatz mit 20 oder 30% Diffusanteil
                                 an sonnigen Tagen*/
   IbT=radiation->Igt_mess-IdT;
   if (IdT<=0) { IdT=0;IbT=0; }
   if (IbT<=0) {       IbT=0; }
   IrT=Rr[unit]*(IbT+IdT);
   if (a) printf("mode E_40###IbT:%.4f  IdT%.4f IrT:%.4f   Igt_mess:%.4f \n"
                ,IbT,IdT,IrT,radiation->Igt_mess);
   IT=IdT+IrT+IbT; /* total radiation */
   radiation->Ibt=IbT;

   radiation->Idt=IdT+IrT; /* diffus + reflec. */
   radiation->Igt=IT;
return (1);
} /* end mode IGT_IGH */


  
  /*  skip some un-unnecessary calcs */
  if (tsim_last!=tsim) { timer-=h; tsim_last=tsim; } 
  if ( (init_flag)||(timer<=0) ) {timer=TIMER_SET_FOR_SKY;timer_flag=1;}
  if (a) printf("rad_proc2:tsim:%.1f mode:%d timer_flag:%d\n",tsim,
         radiation->mode, timer_flag);
  
  /* check input irradiation */
  if ( (Igh!=0) && (radiation->Igt_mess!=0) ) { /* mode Igh,Idh */
    printf("rad_proc2:Igt_mess!=0:%.1f mode Igh-Idh \n",radiation->Igt_mess);
    exit (-1);
  }
  if (Igh<0) Igh=0;
  if (Idh<0) Idh=0;
  if (radiation->mode==IGH_IDH) Ibh=Igh-Idh;
  if (Ibh<0) Ibh=0;

  /* get horizon data and calc shadow situation */
  if ( (init_flag) && (horizon_nr>0) ) { /* on init_flag , get Rd Rr */
    shadow=horizon(init_flag,theta_z_rad,gamma_s_rad,&Rd[unit]
            ,&Rr[unit],rho_g,slope,orientation);

  }
  
 /* static double rad_proc[15]-->*out */
  /* L_st=-15; / * timezone GMT-1 or MEZ ==> 15 east */
  L_st=(-15.0* radiation->timezone);
  if (init_flag) {
   int pedantic=1; /* check timezone explicit */
   /* correct check:
    if ( (*timezone>12) || (*timezone<-12) ) */
   if ( pedantic && 
        ( (radiation->timezone>1.1) || (radiation->timezone<-7 ) 
           || (radiation->timezone==0) )
      ) {
      printf("rad_proc2: timezone:%.2f error \n",radiation->timezone); 
      printf("           set pedantic=0 in use of other timezones \n");
      exit (-1);
   }
   if ( (radiation->length >180) || (radiation->length <-180) ) {
      printf("rad_proc2: length:%.2f error \n",radiation->length); exit (-1); }
  } /* init_flag */ 

  L_loc=radiation->length;

  if (timer_flag) { /* just sometimes */
    locmin=(day_of_year-1)*1440+( (double) tsim) /60.0;
    solartime(&L_st, &L_loc, &locmin, &solmin,&tst);
  }
 
  
  slope*=rad;       /* slope of surface */
                    /* azimut of surface 0:south, west pos */
  orientation*=rad; /* orientation of surface in rad */
                                     /* south=0,west=pi/2 */
  /* -7.85=lenght Freiburg */
  /* GEOGR. BREITE: 50.05 GRAD   GEOGR. LAENGE:  8.58 GRAD */
  /* Shft       = -15-(-1*8.58) */
  hour_angle= rad*( tst - 12 ) *15; /* tst solartime decimal of day [h] */

  if (radiation->latitude==0) {
  printf("time:%.2f len:%.2f lati:%.2f \n",
 radiation->timezone,radiation->length,radiation->latitude);

   printf("rad_proc2: latitude:%.2f error ?(freiburg=48)\n"
          ,radiation->latitude);
   exit (-1);
  }
  else if (local_init) { radiation->latitude*=rad; local_init=0; }
  

  if (a) printf("rad_proc:length:%.1f latitude:%.1f \n",
       radiation->length,radiation->latitude/rad);
  /* Declination:angle between equator-surface and sun 21.jun max=23.45 */
  /* dekl=-23.5*cos( ( 2*pi/365 )*( day_of_year+10)); Goetzberger & Wittwer*/
  /* dekl = 23.45 *rad*sin( rad * 360 * (day_of_year +284) / 365); */
  if (timer_flag) { /* just sometimes */
    dekl=23.45*rad*sin(rad*360*((284+(double) (day_of_year))/ 365)); /*DUF S.13 */
  }

  sin_hour_angle=sin(hour_angle);
  cos_hour_angle=cos(hour_angle);

  if (timer_flag) { /* init A,B,C,D,E */
    A0=sin(dekl)*sin(radiation->latitude);
    B0=sin(dekl)*cos(radiation->latitude);
    C0=cos(dekl)*cos(radiation->latitude);
    D0=cos(dekl)*sin(radiation->latitude);
    E0=cos(dekl);
  }
  A=A0*cos(slope);
  B=B0*sin(slope)*cos(orientation);
  C=C0*cos(slope) /* *cos_hour_angle*/ ;
  D=D0*sin(slope)*cos(orientation) /* *cos_hour_angle*/;
  E=E0*sin(slope)*sin(orientation) /* *sin_hour_angle*/ ;

#if 0
   A=sin(dekl)*sin(latitude1)*cos(slope);
   B=sin(dekl)*cos(latitude1)*sin(slope)*cos(orientation);
   C=cos(dekl)*cos(latitude1)*cos(slope) /* *cos_hour_angle*/ ;
   D=cos(dekl)*sin(latitude1)*sin(slope)*cos(orientation) /* *cos_hour_angle*/;
   E=cos(dekl)*sin(slope)*sin(orientation) /* *sin_hour_angle*/ ;
#endif

  /*
  theta=acos(  sin(dekl)*sin(latitude1)*cos(slope)
            - sin(dekl)*cos(latitude1)*sin(slope)*cos(orientation)
	    + cos(dekl)*cos(latitude1)*cos(slope)*cos(hour_angle)
	    + cos(dekl)*sin(latitude1)*sin(slope)*cos(orientation)
                       *cos(hour_angle)
	    + cos(dekl)*sin(slope)*sin(orientation)*sin(hour_angle)
	    );
  */

  theta=acos( A-B+C*cos_hour_angle+D*cos_hour_angle+E*sin_hour_angle );
  theta_rad=theta/rad;
       
  /*
  theta_z=acos ( 
           cos(latitude1)*cos(dekl)*cos(hour_angle)+sin(latitude1)*sin(dekl) );
  */
  if (timer_flag) { /* just sometimes */
   F=cos(radiation->latitude)*cos(dekl);
   G=sin(radiation->latitude)*sin(dekl);
  }
  theta_z=acos( F*cos_hour_angle+G);
  theta_z_rad=theta_z/rad;

  if (timer_flag) { /* just sometimes */
    /* Brown and Mitchell radiation on plane */
    omega_ew=acos( (tan(dekl)/(tan(radiation->latitude))));
    if ( (radiation->latitude-dekl)>=0 ) C2= 1;
    else                                 C2=-1;
  }
  if ( fabs(hour_angle)  <=omega_ew ) C1= 1;
  else                                C1=-1;
  if ( hour_angle>=0 ) C3= 1;
  else                 C3=-1;

  gamma_s_str=asin( cos(dekl)*sin_hour_angle/sin(theta_z) ) ; 
  gamma_s=rad*( C1*C2*gamma_s_str/rad+C3*(0.5*(1-C1*C2))*180);
  gamma_s_rad=gamma_s/rad;
    
  
  Rb[unit]=cos(theta)/cos(theta_z); 
  if (radiation->mode==IGH_IBN) Rb[unit]=cos(theta);
  if (a) printf("theta:%.1f theta_z:%.1f Rb:%.1f ",theta_rad,theta_z_rad,
                Rb[unit]);

  /* update limits 010816 chriwi: */
  /* Correction necessary since both Ib_hor and cos(teta_z) are very small */
  /* This method seems plausible but yields much less radiation than Trnsys:*/
  /* Calculate extraterrestrial radiation times transmission factor as limit*/
  /* This method almost reproduces Trnsys results:*/
  if ((theta_z>=95.0*rad)||(theta >= 90*rad )) Rb[unit]=0;
  else {
    if (theta_z > 87.0*rad) {
       Rb[unit]=cos(theta)/cos(87.0*rad); /* Keep Rb const.*/
       if (Ibh<=0) Rb[unit]=0;
    } /* if theta_z> 87.0 */
  } /* else theta_z  */


  if (a)  printf("theta=%.2f theta_z=%.2f Rb=%.2f gamma_s=%.2f ",
              theta_rad, theta_z_rad, Rb[unit], gamma_s_rad);

  
  
  /* diffuse radiation: isotropic sky , DUFFI */
  /* Liu an Jordan Duf.S.94 
   IgT=Ibh*Rb+Idh*(0.5*(1+cos(beta)))+Igh*albed*( 0.5*(1-cos(beta)))
  */
  if (Rd_horizon[unit]==0) Rd[unit]=0.5*(1+cos(slope)); /*no ext calc  */
  else                     Rd[unit]=Rd_horizon[unit];

  if (fabs (Rd[unit]) > 2) printf ("rad_proc:Rd=%.2f\n", Rd[unit]); /*reflrad */
  if (Rr_horizon[unit]==0) Rr[unit]=0.5*(1-cos(slope))*rho_g; /* albedo */
  else                     Rr[unit]=Rr_horizon[unit]; /* external calculation */

  if (a) printf("Rd:%.4f Rd_horizon:%.4f Rr:%.4f Rr_horizon:%.4f \n"
            ,0.5*(1+cos(slope)),Rd_horizon[unit],0.5*(1-cos(slope))*rho_g
            ,Rr_horizon[unit]);

  if (fabs(Rr[unit])>2) printf("rad_proc Rr<0:%.4f\n",Rr[unit]);

  IbT=Ibh*Rb[unit];  /* Ibeam correction outside surface */
  if (radiation->mode==IGH_IBN) IbT=Ibn*Rb[unit]; 
  IdT=Idh*Rd[unit]; /* diffus outside surface */
  if (radiation->mode==IGH_IBN) Ibh=Ibn*cos(theta_z);

  IrT=Rr[unit]*(Ibh+Idh);  /* reflective outside surface*/
  IT=IdT+IrT+IbT; /* total radiation */

  /* phi peter: 
   horizontal_to_tilted(theta_z,gamma_s,orientation,slope,&theta,&phi); */

  /* get horizon data and calc shadow situation */
  if (horizon_nr>0)  { /*  get Rd Rr */
    shadow=horizon(init_flag,theta_z_rad,gamma_s_rad,&Rd[unit]
            ,&Rr[unit],rho_g,slope,orientation);
  }

  if ( (shadow>0) && (Rb[unit]>0) ) 
      printf("################## shadow:%.2f \n",shadow);

  if (b0==0) { 
    printf("rad_proc2: b0 not set , using default-0.12 \n"); 
    b0=-0.12; 
  }
  /* calc inc_angl_modifier */
  inc_angl=inc_angl_mod2(init_flag,b0,theta_rad,phi_rad,&iam_diff);
  if (init_flag) radiation->iam_diff=iam_diff; /* rewrite iam_diff */

  if (b0==1) {
    printf("rad_proc2: b0=1 , using no inc_angl_modifier \n"); 
    inc_angl=1;
  }
  if ( (inc_angl>1) || (inc_angl<0) ) { 
    printf("rad_proc2:inc_angl error:%.2f\n",inc_angl); exit (-1);
  }
  /* write radiations on wall (with horizon, without iam or shading element) */
  radiation->Ibt=IbT*(1-shadow);
  radiation->Idt=(IdT+IrT); /* diffus + reflective */
  radiation->Igt=radiation->Ibt+radiation->Idt;
  radiation->theta_z=theta_z_rad; /* solar zenith  */
  radiation->gamma_s=gamma_s_rad; /* solar azimut */
  radiation->Rd=Rd[unit];
  radiation->Rr=Rr[unit];
  radiation->inc_angl=inc_angl;
  radiation->theta=theta;

  if ((radiation->mode_shading==1) /* shading */
      &&(radiation->shading_unit!=radiation->wall_unit)) { 
    shading(info,interface,radiation);
    /* shading writes the radiations which go thru glazing on himself */
   }
  else { /* no shading */
    /* write radiations which go thru glazing (with horizon and iam) */
    radiation->Ibt_trans=inc_angl*IbT*(1-shadow);
    radiation->Idt_trans=(IdT+IrT)*iam_diff;
    radiation->Igt_trans=radiation->Ibt_trans+radiation->Idt_trans;
   } 
if (0) printf("tsim:%.1f radiation->Ibt:%.1f IbT:%.1f Igt:%.1f\n"
              ,info->tsim,radiation->Ibt,IbT,radiation->Igt);

  return (1);
} /* rad_proc2 */

