/*
type_call.orig.c 
!!! auto modified by cfg/config --> type_call.c 

 * Copyright (C) 1995  Christof Wittwer
 * All rights reserved.
 *
 * This software may be freely copied, modified, and redistributed
 * provided that this copyright notice is preserved on all copies.
 *
 * You may not distribute this software, in whole or in part, as part of
 * any commercial product without the express consent of the authors.
 *
 * There is no warranty or other guarantee of fitness of this software
 * for any purpose.  It is provided solely "as is".
 *
*/

/*
001109 type_call argument out_label included
010517 i_dead_no erased
010627 skip_time_intervall,**thermo_struct added to type_call()
010827 sim_struct added
010920 timezone added to args of type_call
010925 rad_processor.h included
*/
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "global.h"
#include "rad_processor.h"

int type_call(
              struct sim_struct *info, /* see global.h */
              struct interface_struct *interface,
              struct radiation_struct *radiation,
              char **type_def_str,
              int unit,
              int un_max,
              int *type,
              int *select_unit,
              int *type_index, 
              int init_flag,
              double *timezone,
              double *lenght,
              double *latitude,
              int day_of_year,
              int year_start,
              int month,
              int day,
              int hour,
              int min,
              int sec,
              int day_flag,
              int hour_flag,
              int week_flag,
              int day_of_week,
              int min10_flag,
              int stop_flag,
              int previous_unit,
              int **in_u,
              int **in_nr,
              double **iam,
              double h,
              double tsim,
              double **par,
              double **out_n,
              double **out_o,
              double **deriv_o,
              double **deriv_n,
              double **init_energy,
              double **Qi,
              double **Q, /* pipe */
              double ***qp_sum,
              int    a,
              int    *unit_order,
              int    nr_of_unit_calls,
              double **dummy,
              char ***out_label,
              double skip_time_intervall,
              struct therm_hydraulic_struct **thermo_struct
             )
{

static int init_local_flag=1;
int unix_flag=1;
int check=0;


if (init_local_flag) {
 init_local_flag=0;
 }

			
switch (type[unit])  
  { 
  case 0:
    break;
  /* ###### BEGIN CASE_LOOP ### don't erase this pattern !!!!!##############*/
  /* cfg/config uses this pattern to substitude case loop */
  case 1:   /* TYPE 1 */
    check=collector(unit,par,in_u,in_nr,out_n,out_o,
                    deriv_o,deriv_n,h,init_energy,qp_sum,
                    tsim,init_flag,i_dead_nr,Q,min10_flag,day_of_year,
                    un_max,lenght,latitude,iam
                   );
    break;
  case 2:   /* TYPE 2 */
    check=controller(unit,par,in_u,in_nr,out_o,out_n,qp_sum,tsim,init_flag,h);
    break;
  ...
  ...
  etc dummy code 
  /* ###### END CASE_LOOP ### don't erase this pattern !!!!!##############*/
  default:
     printf("unknown TYPE:%d unit:%d exit\n",type[unit],unit);exit (-1);
     } /*case-end*/

return (check);
} /* type_call() */

